/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2017 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
define(["exports","./defined-2a4f2d00","./Check-e5651467","./freezeObject-a51e076f","./defaultValue-29c9b1af","./Math-7782f09e","./Cartesian2-ba70b51f","./defineProperties-c817531e","./RuntimeError-51c34ab4","./when-1faa3867"],function(e,I,n,t,P,H,D,r,J,d){"use strict";function a(e){this._ellipsoid=P.defaultValue(e,D.Ellipsoid.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}r.defineProperties(a.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),a.prototype.project=function(e,t){var n=this._semimajorAxis,r=e.longitude*n,a=e.latitude*n,i=e.height;return I.defined(t)?(t.x=r,t.y=a,t.z=i,t):new D.Cartesian3(r,a,i)},a.prototype.unproject=function(e,t){var n=this._oneOverSemimajorAxis,r=e.x*n,a=e.y*n,i=e.z;return I.defined(t)?(t.longitude=r,t.latitude=a,t.height=i,t):new D.Cartographic(r,a,i)};var s=t.freezeObject({OUTSIDE:-1,INTERSECTING:0,INSIDE:1});function o(e,t){this.start=P.defaultValue(e,0),this.stop=P.defaultValue(t,0)}function X(e,t,n,r,a,i,s,o,u){this[0]=P.defaultValue(e,0),this[1]=P.defaultValue(r,0),this[2]=P.defaultValue(s,0),this[3]=P.defaultValue(t,0),this[4]=P.defaultValue(a,0),this[5]=P.defaultValue(o,0),this[6]=P.defaultValue(n,0),this[7]=P.defaultValue(i,0),this[8]=P.defaultValue(u,0)}X.packedLength=9,X.pack=function(e,t,n){return n=P.defaultValue(n,0),t[n++]=e[0],t[n++]=e[1],t[n++]=e[2],t[n++]=e[3],t[n++]=e[4],t[n++]=e[5],t[n++]=e[6],t[n++]=e[7],t[n++]=e[8],t},X.unpack=function(e,t,n){return t=P.defaultValue(t,0),I.defined(n)||(n=new X),n[0]=e[t++],n[1]=e[t++],n[2]=e[t++],n[3]=e[t++],n[4]=e[t++],n[5]=e[t++],n[6]=e[t++],n[7]=e[t++],n[8]=e[t++],n},X.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t):new X(e[0],e[3],e[6],e[1],e[4],e[7],e[2],e[5],e[8])},X.fromArray=function(e,t,n){return t=P.defaultValue(t,0),I.defined(n)||(n=new X),n[0]=e[t],n[1]=e[t+1],n[2]=e[t+2],n[3]=e[t+3],n[4]=e[t+4],n[5]=e[t+5],n[6]=e[t+6],n[7]=e[t+7],n[8]=e[t+8],n},X.fromColumnMajorArray=function(e,t){return X.clone(e,t)},X.fromRowMajorArray=function(e,t){return I.defined(t)?(t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8],t):new X(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8])},X.fromQuaternion=function(e,t){var n=e.x*e.x,r=e.x*e.y,a=e.x*e.z,i=e.x*e.w,s=e.y*e.y,o=e.y*e.z,u=e.y*e.w,l=e.z*e.z,c=e.z*e.w,f=e.w*e.w,d=n-s-l+f,h=2*(r-c),p=2*(a+u),m=2*(r+c),y=s-n-l+f,v=2*(o-i),w=2*(a-u),C=2*(o+i),g=-n-s+l+f;return I.defined(t)?(t[0]=d,t[1]=m,t[2]=w,t[3]=h,t[4]=y,t[5]=C,t[6]=p,t[7]=v,t[8]=g,t):new X(d,h,p,m,y,v,w,C,g)},X.fromHeadingPitchRoll=function(e,t){var n=Math.cos(-e.pitch),r=Math.cos(-e.heading),a=Math.cos(e.roll),i=Math.sin(-e.pitch),s=Math.sin(-e.heading),o=Math.sin(e.roll),u=n*r,l=-a*s+o*i*r,c=o*s+a*i*r,f=n*s,d=a*r+o*i*s,h=-o*r+a*i*s,p=-i,m=o*n,y=a*n;return I.defined(t)?(t[0]=u,t[1]=f,t[2]=p,t[3]=l,t[4]=d,t[5]=m,t[6]=c,t[7]=h,t[8]=y,t):new X(u,l,c,f,d,h,p,m,y)},X.fromScale=function(e,t){return I.defined(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=0,t[4]=e.y,t[5]=0,t[6]=0,t[7]=0,t[8]=e.z,t):new X(e.x,0,0,0,e.y,0,0,0,e.z)},X.fromUniformScale=function(e,t){return I.defined(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=e,t[5]=0,t[6]=0,t[7]=0,t[8]=e,t):new X(e,0,0,0,e,0,0,0,e)},X.fromCrossProduct=function(e,t){return I.defined(t)?(t[0]=0,t[1]=e.z,t[2]=-e.y,t[3]=-e.z,t[4]=0,t[5]=e.x,t[6]=e.y,t[7]=-e.x,t[8]=0,t):new X(0,-e.z,e.y,e.z,0,-e.x,-e.y,e.x,0)},X.fromRotationX=function(e,t){var n=Math.cos(e),r=Math.sin(e);return I.defined(t)?(t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=n,t[5]=r,t[6]=0,t[7]=-r,t[8]=n,t):new X(1,0,0,0,n,-r,0,r,n)},X.fromRotationY=function(e,t){var n=Math.cos(e),r=Math.sin(e);return I.defined(t)?(t[0]=n,t[1]=0,t[2]=-r,t[3]=0,t[4]=1,t[5]=0,t[6]=r,t[7]=0,t[8]=n,t):new X(n,0,r,0,1,0,-r,0,n)},X.fromRotationZ=function(e,t){var n=Math.cos(e),r=Math.sin(e);return I.defined(t)?(t[0]=n,t[1]=r,t[2]=0,t[3]=-r,t[4]=n,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t):new X(n,-r,0,r,n,0,0,0,1)},X.toArray=function(e,t){return I.defined(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8]]},X.getElementIndex=function(e,t){return 3*e+t},X.getColumn=function(e,t,n){var r=3*t,a=e[r],i=e[1+r],s=e[2+r];return n.x=a,n.y=i,n.z=s,n},X.setColumn=function(e,t,n,r){var a=3*t;return(r=X.clone(e,r))[a]=n.x,r[1+a]=n.y,r[2+a]=n.z,r},X.getRow=function(e,t,n){var r=e[t],a=e[t+3],i=e[t+6];return n.x=r,n.y=a,n.z=i,n},X.setRow=function(e,t,n,r){return(r=X.clone(e,r))[t]=n.x,r[t+3]=n.y,r[t+6]=n.z,r};var i=new D.Cartesian3;X.getScale=function(e,t){return t.x=D.Cartesian3.magnitude(D.Cartesian3.fromElements(e[0],e[1],e[2],i)),t.y=D.Cartesian3.magnitude(D.Cartesian3.fromElements(e[3],e[4],e[5],i)),t.z=D.Cartesian3.magnitude(D.Cartesian3.fromElements(e[6],e[7],e[8],i)),t};var u=new D.Cartesian3;X.getMaximumScale=function(e){return X.getScale(e,u),D.Cartesian3.maximumComponent(u)},X.multiply=function(e,t,n){var r=e[0]*t[0]+e[3]*t[1]+e[6]*t[2],a=e[1]*t[0]+e[4]*t[1]+e[7]*t[2],i=e[2]*t[0]+e[5]*t[1]+e[8]*t[2],s=e[0]*t[3]+e[3]*t[4]+e[6]*t[5],o=e[1]*t[3]+e[4]*t[4]+e[7]*t[5],u=e[2]*t[3]+e[5]*t[4]+e[8]*t[5],l=e[0]*t[6]+e[3]*t[7]+e[6]*t[8],c=e[1]*t[6]+e[4]*t[7]+e[7]*t[8],f=e[2]*t[6]+e[5]*t[7]+e[8]*t[8];return n[0]=r,n[1]=a,n[2]=i,n[3]=s,n[4]=o,n[5]=u,n[6]=l,n[7]=c,n[8]=f,n},X.add=function(e,t,n){return n[0]=e[0]+t[0],n[1]=e[1]+t[1],n[2]=e[2]+t[2],n[3]=e[3]+t[3],n[4]=e[4]+t[4],n[5]=e[5]+t[5],n[6]=e[6]+t[6],n[7]=e[7]+t[7],n[8]=e[8]+t[8],n},X.subtract=function(e,t,n){return n[0]=e[0]-t[0],n[1]=e[1]-t[1],n[2]=e[2]-t[2],n[3]=e[3]-t[3],n[4]=e[4]-t[4],n[5]=e[5]-t[5],n[6]=e[6]-t[6],n[7]=e[7]-t[7],n[8]=e[8]-t[8],n},X.multiplyByVector=function(e,t,n){var r=t.x,a=t.y,i=t.z,s=e[0]*r+e[3]*a+e[6]*i,o=e[1]*r+e[4]*a+e[7]*i,u=e[2]*r+e[5]*a+e[8]*i;return n.x=s,n.y=o,n.z=u,n},X.multiplyByScalar=function(e,t,n){return n[0]=e[0]*t,n[1]=e[1]*t,n[2]=e[2]*t,n[3]=e[3]*t,n[4]=e[4]*t,n[5]=e[5]*t,n[6]=e[6]*t,n[7]=e[7]*t,n[8]=e[8]*t,n},X.multiplyByScale=function(e,t,n){return n[0]=e[0]*t.x,n[1]=e[1]*t.x,n[2]=e[2]*t.x,n[3]=e[3]*t.y,n[4]=e[4]*t.y,n[5]=e[5]*t.y,n[6]=e[6]*t.z,n[7]=e[7]*t.z,n[8]=e[8]*t.z,n},X.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=-e[7],t[8]=-e[8],t},X.transpose=function(e,t){var n=e[0],r=e[3],a=e[6],i=e[1],s=e[4],o=e[7],u=e[2],l=e[5],c=e[8];return t[0]=n,t[1]=r,t[2]=a,t[3]=i,t[4]=s,t[5]=o,t[6]=u,t[7]=l,t[8]=c,t};var l=new D.Cartesian3(1,1,1);X.getRotation=function(e,t){var n=D.Cartesian3.divideComponents(l,X.getScale(e,u),u);return t=X.multiplyByScale(e,n,t)};var h=[1,0,0],p=[2,2,1];function c(e){for(var t=0,n=0;n<3;++n){var r=e[X.getElementIndex(p[n],h[n])];t+=2*r*r}return Math.sqrt(t)}function f(e,t){for(var n=H.CesiumMath.EPSILON15,r=0,a=1,i=0;i<3;++i){var s=Math.abs(e[X.getElementIndex(p[i],h[i])]);r<s&&(a=i,r=s)}var o=1,u=0,l=h[a],c=p[a];if(Math.abs(e[X.getElementIndex(c,l)])>n){var f,d=(e[X.getElementIndex(c,c)]-e[X.getElementIndex(l,l)])/2/e[X.getElementIndex(c,l)];u=(f=d<0?-1/(-d+Math.sqrt(1+d*d)):1/(d+Math.sqrt(1+d*d)))*(o=1/Math.sqrt(1+f*f))}return(t=X.clone(X.IDENTITY,t))[X.getElementIndex(l,l)]=t[X.getElementIndex(c,c)]=o,t[X.getElementIndex(c,l)]=u,t[X.getElementIndex(l,c)]=-u,t}var m=new X,y=new X;function G(e,t,n,r){this.x=P.defaultValue(e,0),this.y=P.defaultValue(t,0),this.z=P.defaultValue(n,0),this.w=P.defaultValue(r,0)}X.computeEigenDecomposition=function(e,t){var n=H.CesiumMath.EPSILON20,r=0,a=0;I.defined(t)||(t={});for(var i=t.unitary=X.clone(X.IDENTITY,t.unitary),s=t.diagonal=X.clone(e,t.diagonal),o=n*function(e){for(var t=0,n=0;n<9;++n){var r=e[n];t+=r*r}return Math.sqrt(t)}(s);a<10&&c(s)>o;)f(s,m),X.transpose(m,y),X.multiply(s,m,s),X.multiply(y,s,s),X.multiply(i,m,i),2<++r&&(++a,r=0);return t},X.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t[4]=Math.abs(e[4]),t[5]=Math.abs(e[5]),t[6]=Math.abs(e[6]),t[7]=Math.abs(e[7]),t[8]=Math.abs(e[8]),t},X.determinant=function(e){var t=e[0],n=e[3],r=e[6],a=e[1],i=e[4],s=e[7],o=e[2],u=e[5],l=e[8];return t*(i*l-u*s)+a*(u*r-n*l)+o*(n*s-i*r)},X.inverse=function(e,t){var n=e[0],r=e[1],a=e[2],i=e[3],s=e[4],o=e[5],u=e[6],l=e[7],c=e[8],f=X.determinant(e);return t[0]=s*c-l*o,t[1]=l*a-r*c,t[2]=r*o-s*a,t[3]=u*o-i*c,t[4]=n*c-u*a,t[5]=i*a-n*o,t[6]=i*l-u*s,t[7]=u*r-n*l,t[8]=n*s-i*r,X.multiplyByScalar(t,1/f,t)},X.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]},X.equalsEpsilon=function(e,t,n){return e===t||I.defined(e)&&I.defined(t)&&Math.abs(e[0]-t[0])<=n&&Math.abs(e[1]-t[1])<=n&&Math.abs(e[2]-t[2])<=n&&Math.abs(e[3]-t[3])<=n&&Math.abs(e[4]-t[4])<=n&&Math.abs(e[5]-t[5])<=n&&Math.abs(e[6]-t[6])<=n&&Math.abs(e[7]-t[7])<=n&&Math.abs(e[8]-t[8])<=n},X.IDENTITY=t.freezeObject(new X(1,0,0,0,1,0,0,0,1)),X.ZERO=t.freezeObject(new X(0,0,0,0,0,0,0,0,0)),X.COLUMN0ROW0=0,X.COLUMN0ROW1=1,X.COLUMN0ROW2=2,X.COLUMN1ROW0=3,X.COLUMN1ROW1=4,X.COLUMN1ROW2=5,X.COLUMN2ROW0=6,X.COLUMN2ROW1=7,X.COLUMN2ROW2=8,r.defineProperties(X.prototype,{length:{get:function(){return X.packedLength}}}),X.prototype.clone=function(e){return X.clone(this,e)},X.prototype.equals=function(e){return X.equals(this,e)},X.equalsArray=function(e,t,n){return e[0]===t[n]&&e[1]===t[n+1]&&e[2]===t[n+2]&&e[3]===t[n+3]&&e[4]===t[n+4]&&e[5]===t[n+5]&&e[6]===t[n+6]&&e[7]===t[n+7]&&e[8]===t[n+8]},X.prototype.equalsEpsilon=function(e,t){return X.equalsEpsilon(this,e,t)},X.prototype.toString=function(){return"("+this[0]+", "+this[3]+", "+this[6]+")\n("+this[1]+", "+this[4]+", "+this[7]+")\n("+this[2]+", "+this[5]+", "+this[8]+")"},G.fromElements=function(e,t,n,r,a){return I.defined(a)?(a.x=e,a.y=t,a.z=n,a.w=r,a):new G(e,t,n,r)},G.fromColor=function(e,t){return I.defined(t)?(t.x=e.red,t.y=e.green,t.z=e.blue,t.w=e.alpha,t):new G(e.red,e.green,e.blue,e.alpha)},G.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t):new G(e.x,e.y,e.z,e.w)},G.packedLength=4,G.pack=function(e,t,n){return n=P.defaultValue(n,0),t[n++]=e.x,t[n++]=e.y,t[n++]=e.z,t[n]=e.w,t},G.unpack=function(e,t,n){return t=P.defaultValue(t,0),I.defined(n)||(n=new G),n.x=e[t++],n.y=e[t++],n.z=e[t++],n.w=e[t],n},G.packArray=function(e,t){var n=e.length;I.defined(t)?t.length=4*n:t=new Array(4*n);for(var r=0;r<n;++r)G.pack(e[r],t,4*r);return t},G.unpackArray=function(e,t){var n=e.length;I.defined(t)?t.length=n/4:t=new Array(n/4);for(var r=0;r<n;r+=4){var a=r/4;t[a]=G.unpack(e,r,t[a])}return t},G.fromArray=G.unpack,G.maximumComponent=function(e){return Math.max(e.x,e.y,e.z,e.w)},G.minimumComponent=function(e){return Math.min(e.x,e.y,e.z,e.w)},G.minimumByComponent=function(e,t,n){return n.x=Math.min(e.x,t.x),n.y=Math.min(e.y,t.y),n.z=Math.min(e.z,t.z),n.w=Math.min(e.w,t.w),n},G.maximumByComponent=function(e,t,n){return n.x=Math.max(e.x,t.x),n.y=Math.max(e.y,t.y),n.z=Math.max(e.z,t.z),n.w=Math.max(e.w,t.w),n},G.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z+e.w*e.w},G.magnitude=function(e){return Math.sqrt(G.magnitudeSquared(e))};var v=new G;G.distance=function(e,t){return G.subtract(e,t,v),G.magnitude(v)},G.distanceSquared=function(e,t){return G.subtract(e,t,v),G.magnitudeSquared(v)},G.normalize=function(e,t){var n=G.magnitude(e);return t.x=e.x/n,t.y=e.y/n,t.z=e.z/n,t.w=e.w/n,t},G.dot=function(e,t){return e.x*t.x+e.y*t.y+e.z*t.z+e.w*t.w},G.multiplyComponents=function(e,t,n){return n.x=e.x*t.x,n.y=e.y*t.y,n.z=e.z*t.z,n.w=e.w*t.w,n},G.divideComponents=function(e,t,n){return n.x=e.x/t.x,n.y=e.y/t.y,n.z=e.z/t.z,n.w=e.w/t.w,n},G.add=function(e,t,n){return n.x=e.x+t.x,n.y=e.y+t.y,n.z=e.z+t.z,n.w=e.w+t.w,n},G.subtract=function(e,t,n){return n.x=e.x-t.x,n.y=e.y-t.y,n.z=e.z-t.z,n.w=e.w-t.w,n},G.multiplyByScalar=function(e,t,n){return n.x=e.x*t,n.y=e.y*t,n.z=e.z*t,n.w=e.w*t,n},G.divideByScalar=function(e,t,n){return n.x=e.x/t,n.y=e.y/t,n.z=e.z/t,n.w=e.w/t,n},G.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=-e.w,t},G.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t.z=Math.abs(e.z),t.w=Math.abs(e.w),t};var w=new G;G.lerp=function(e,t,n,r){return G.multiplyByScalar(t,n,w),r=G.multiplyByScalar(e,1-n,r),G.add(w,r,r)};var C=new G;G.mostOrthogonalAxis=function(e,t){var n=G.normalize(e,C);return G.abs(n,n),t=n.x<=n.y?n.x<=n.z?n.x<=n.w?G.clone(G.UNIT_X,t):G.clone(G.UNIT_W,t):n.z<=n.w?G.clone(G.UNIT_Z,t):G.clone(G.UNIT_W,t):n.y<=n.z?n.y<=n.w?G.clone(G.UNIT_Y,t):G.clone(G.UNIT_W,t):n.z<=n.w?G.clone(G.UNIT_Z,t):G.clone(G.UNIT_W,t)},G.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&e.x===t.x&&e.y===t.y&&e.z===t.z&&e.w===t.w},G.equalsArray=function(e,t,n){return e.x===t[n]&&e.y===t[n+1]&&e.z===t[n+2]&&e.w===t[n+3]},G.equalsEpsilon=function(e,t,n,r){return e===t||I.defined(e)&&I.defined(t)&&H.CesiumMath.equalsEpsilon(e.x,t.x,n,r)&&H.CesiumMath.equalsEpsilon(e.y,t.y,n,r)&&H.CesiumMath.equalsEpsilon(e.z,t.z,n,r)&&H.CesiumMath.equalsEpsilon(e.w,t.w,n,r)},G.ZERO=t.freezeObject(new G(0,0,0,0)),G.UNIT_X=t.freezeObject(new G(1,0,0,0)),G.UNIT_Y=t.freezeObject(new G(0,1,0,0)),G.UNIT_Z=t.freezeObject(new G(0,0,1,0)),G.UNIT_W=t.freezeObject(new G(0,0,0,1)),G.prototype.clone=function(e){return G.clone(this,e)},G.prototype.equals=function(e){return G.equals(this,e)},G.prototype.equalsEpsilon=function(e,t,n){return G.equalsEpsilon(this,e,t,n)},G.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"};var g=new Float32Array(1),x=256;function Q(e,t,n,r,a,i,s,o,u,l,c,f,d,h,p,m){this[0]=P.defaultValue(e,0),this[1]=P.defaultValue(a,0),this[2]=P.defaultValue(u,0),this[3]=P.defaultValue(d,0),this[4]=P.defaultValue(t,0),this[5]=P.defaultValue(i,0),this[6]=P.defaultValue(l,0),this[7]=P.defaultValue(h,0),this[8]=P.defaultValue(n,0),this[9]=P.defaultValue(s,0),this[10]=P.defaultValue(c,0),this[11]=P.defaultValue(p,0),this[12]=P.defaultValue(r,0),this[13]=P.defaultValue(o,0),this[14]=P.defaultValue(f,0),this[15]=P.defaultValue(m,0)}G.packFloat=function(e,t){if(I.defined(t)||(t=new G),g[0]=e,0===(e=g[0]))return G.clone(G.ZERO,t);var n,r=e<0?1:0;isFinite(e)?(e=Math.abs(e),n=Math.floor(H.CesiumMath.logBase(e,10))+1,e/=Math.pow(10,n)):(e=.1,n=38);var a=e*x;return t.x=Math.floor(a),a=(a-t.x)*x,t.y=Math.floor(a),a=(a-t.y)*x,t.z=Math.floor(a),t.w=2*(n+38)+r,t},G.unpackFloat=function(e){var t=e.w/2,n=Math.floor(t),r=2*(t-n);if(r=-(r=2*r-1),38<=(n-=38))return r<0?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY;var a=r*e.x*.00390625;return a+=r*e.y*(1/65536),(a+=r*e.z*(1/16777216))*Math.pow(10,n)},Q.packedLength=16,Q.pack=function(e,t,n){return n=P.defaultValue(n,0),t[n++]=e[0],t[n++]=e[1],t[n++]=e[2],t[n++]=e[3],t[n++]=e[4],t[n++]=e[5],t[n++]=e[6],t[n++]=e[7],t[n++]=e[8],t[n++]=e[9],t[n++]=e[10],t[n++]=e[11],t[n++]=e[12],t[n++]=e[13],t[n++]=e[14],t[n]=e[15],t},Q.unpack=function(e,t,n){return t=P.defaultValue(t,0),I.defined(n)||(n=new Q),n[0]=e[t++],n[1]=e[t++],n[2]=e[t++],n[3]=e[t++],n[4]=e[t++],n[5]=e[t++],n[6]=e[t++],n[7]=e[t++],n[8]=e[t++],n[9]=e[t++],n[10]=e[t++],n[11]=e[t++],n[12]=e[t++],n[13]=e[t++],n[14]=e[t++],n[15]=e[t],n},Q.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t):new Q(e[0],e[4],e[8],e[12],e[1],e[5],e[9],e[13],e[2],e[6],e[10],e[14],e[3],e[7],e[11],e[15])},Q.fromArray=Q.unpack,Q.fromColumnMajorArray=function(e,t){return Q.clone(e,t)},Q.fromRowMajorArray=function(e,t){return I.defined(t)?(t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15],t):new Q(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15])},Q.fromRotationTranslation=function(e,t,n){return t=P.defaultValue(t,D.Cartesian3.ZERO),I.defined(n)?(n[0]=e[0],n[1]=e[1],n[2]=e[2],n[3]=0,n[4]=e[3],n[5]=e[4],n[6]=e[5],n[7]=0,n[8]=e[6],n[9]=e[7],n[10]=e[8],n[11]=0,n[12]=t.x,n[13]=t.y,n[14]=t.z,n[15]=1,n):new Q(e[0],e[3],e[6],t.x,e[1],e[4],e[7],t.y,e[2],e[5],e[8],t.z,0,0,0,1)},Q.fromTranslationQuaternionRotationScale=function(e,t,n,r){I.defined(r)||(r=new Q);var a=n.x,i=n.y,s=n.z,o=t.x*t.x,u=t.x*t.y,l=t.x*t.z,c=t.x*t.w,f=t.y*t.y,d=t.y*t.z,h=t.y*t.w,p=t.z*t.z,m=t.z*t.w,y=t.w*t.w,v=o-f-p+y,w=2*(u-m),C=2*(l+h),g=2*(u+m),x=f-o-p+y,E=2*(d-c),O=2*(l-h),_=2*(d+c),S=-o-f+p+y;return r[0]=v*a,r[1]=g*a,r[2]=O*a,r[3]=0,r[4]=w*i,r[5]=x*i,r[6]=_*i,r[7]=0,r[8]=C*s,r[9]=E*s,r[10]=S*s,r[11]=0,r[12]=e.x,r[13]=e.y,r[14]=e.z,r[15]=1,r},Q.fromTranslationRotationScale=function(e,t){return Q.fromTranslationQuaternionRotationScale(e.translation,e.rotation,e.scale,t)},Q.fromTranslation=function(e,t){return Q.fromRotationTranslation(X.IDENTITY,e,t)},Q.fromScale=function(e,t){return I.defined(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e.y,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e.z,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t):new Q(e.x,0,0,0,0,e.y,0,0,0,0,e.z,0,0,0,0,1)},Q.fromUniformScale=function(e,t){return I.defined(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t):new Q(e,0,0,0,0,e,0,0,0,0,e,0,0,0,0,1)};var E=new D.Cartesian3,O=new D.Cartesian3,_=new D.Cartesian3;Q.fromCamera=function(e,t){var n=e.position,r=e.direction,a=e.up;D.Cartesian3.normalize(r,E),D.Cartesian3.normalize(D.Cartesian3.cross(E,a,O),O),D.Cartesian3.normalize(D.Cartesian3.cross(O,E,_),_);var i=O.x,s=O.y,o=O.z,u=E.x,l=E.y,c=E.z,f=_.x,d=_.y,h=_.z,p=n.x,m=n.y,y=n.z,v=i*-p+s*-m+o*-y,w=f*-p+d*-m+h*-y,C=u*p+l*m+c*y;return I.defined(t)?(t[0]=i,t[1]=f,t[2]=-u,t[3]=0,t[4]=s,t[5]=d,t[6]=-l,t[7]=0,t[8]=o,t[9]=h,t[10]=-c,t[11]=0,t[12]=v,t[13]=w,t[14]=C,t[15]=1,t):new Q(i,s,o,v,f,d,h,w,-u,-l,-c,C,0,0,0,1)},Q.computePerspectiveFieldOfView=function(e,t,n,r,a){var i=1/Math.tan(.5*e),s=i/t,o=(r+n)/(n-r),u=2*r*n/(n-r);return a[0]=s,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=i,a[6]=0,a[7]=0,a[8]=0,a[9]=0,a[10]=o,a[11]=-1,a[12]=0,a[13]=0,a[14]=u,a[15]=0,a},Q.computeOrthographicOffCenter=function(e,t,n,r,a,i,s){var o=1/(t-e),u=1/(r-n),l=1/(i-a),c=-(t+e)*o,f=-(r+n)*u,d=-(i+a)*l;return o*=2,u*=2,l*=-2,s[0]=o,s[1]=0,s[2]=0,s[3]=0,s[4]=0,s[5]=u,s[6]=0,s[7]=0,s[8]=0,s[9]=0,s[10]=l,s[11]=0,s[12]=c,s[13]=f,s[14]=d,s[15]=1,s},Q.computePerspectiveOffCenter=function(e,t,n,r,a,i,s){var o=2*a/(t-e),u=2*a/(r-n),l=(t+e)/(t-e),c=(r+n)/(r-n),f=-(i+a)/(i-a),d=-2*i*a/(i-a);return s[0]=o,s[1]=0,s[2]=0,s[3]=0,s[4]=0,s[5]=u,s[6]=0,s[7]=0,s[8]=l,s[9]=c,s[10]=f,s[11]=-1,s[12]=0,s[13]=0,s[14]=d,s[15]=0,s},Q.computeInfinitePerspectiveOffCenter=function(e,t,n,r,a,i){var s=2*a/(t-e),o=2*a/(r-n),u=(t+e)/(t-e),l=(r+n)/(r-n),c=-2*a;return i[0]=s,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=o,i[6]=0,i[7]=0,i[8]=u,i[9]=l,i[10]=-1,i[11]=-1,i[12]=0,i[13]=0,i[14]=c,i[15]=0,i},Q.computeViewportTransformation=function(e,t,n,r){e=P.defaultValue(e,P.defaultValue.EMPTY_OBJECT);var a=P.defaultValue(e.x,0),i=P.defaultValue(e.y,0),s=P.defaultValue(e.width,0),o=P.defaultValue(e.height,0);t=P.defaultValue(t,0);var u=.5*s,l=.5*o,c=.5*((n=P.defaultValue(n,1))-t),f=u,d=l,h=c,p=a+u,m=i+l,y=t+c;return r[0]=f,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=d,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=h,r[11]=0,r[12]=p,r[13]=m,r[14]=y,r[15]=1,r},Q.computeView=function(e,t,n,r,a){return a[0]=r.x,a[1]=n.x,a[2]=-t.x,a[3]=0,a[4]=r.y,a[5]=n.y,a[6]=-t.y,a[7]=0,a[8]=r.z,a[9]=n.z,a[10]=-t.z,a[11]=0,a[12]=-D.Cartesian3.dot(r,e),a[13]=-D.Cartesian3.dot(n,e),a[14]=D.Cartesian3.dot(t,e),a[15]=1,a},Q.toArray=function(e,t){return I.defined(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15]]},Q.getElementIndex=function(e,t){return 4*e+t},Q.getColumn=function(e,t,n){var r=4*t,a=e[r],i=e[1+r],s=e[2+r],o=e[3+r];return n.x=a,n.y=i,n.z=s,n.w=o,n},Q.setColumn=function(e,t,n,r){var a=4*t;return(r=Q.clone(e,r))[a]=n.x,r[1+a]=n.y,r[2+a]=n.z,r[3+a]=n.w,r},Q.setTranslation=function(e,t,n){return n[0]=e[0],n[1]=e[1],n[2]=e[2],n[3]=e[3],n[4]=e[4],n[5]=e[5],n[6]=e[6],n[7]=e[7],n[8]=e[8],n[9]=e[9],n[10]=e[10],n[11]=e[11],n[12]=t.x,n[13]=t.y,n[14]=t.z,n[15]=e[15],n};var S=new D.Cartesian3;Q.setScale=function(e,t,n){var r=Q.getScale(e,S),a=D.Cartesian3.divideComponents(t,r,S);return Q.multiplyByScale(e,a,n)},Q.getRow=function(e,t,n){var r=e[t],a=e[t+4],i=e[t+8],s=e[t+12];return n.x=r,n.y=a,n.z=i,n.w=s,n},Q.setRow=function(e,t,n,r){return(r=Q.clone(e,r))[t]=n.x,r[t+4]=n.y,r[t+8]=n.z,r[t+12]=n.w,r};var b=new D.Cartesian3;Q.getScale=function(e,t){return t.x=D.Cartesian3.magnitude(D.Cartesian3.fromElements(e[0],e[1],e[2],b)),t.y=D.Cartesian3.magnitude(D.Cartesian3.fromElements(e[4],e[5],e[6],b)),t.z=D.Cartesian3.magnitude(D.Cartesian3.fromElements(e[8],e[9],e[10],b)),t};var M=new D.Cartesian3;Q.getMaximumScale=function(e){return Q.getScale(e,M),D.Cartesian3.maximumComponent(M)},Q.multiply=function(e,t,n){var r=e[0],a=e[1],i=e[2],s=e[3],o=e[4],u=e[5],l=e[6],c=e[7],f=e[8],d=e[9],h=e[10],p=e[11],m=e[12],y=e[13],v=e[14],w=e[15],C=t[0],g=t[1],x=t[2],E=t[3],O=t[4],_=t[5],S=t[6],b=t[7],M=t[8],A=t[9],R=t[10],T=t[11],z=t[12],q=t[13],I=t[14],P=t[15],D=r*C+o*g+f*x+m*E,N=a*C+u*g+d*x+y*E,U=i*C+l*g+h*x+v*E,F=s*C+c*g+p*x+w*E,V=r*O+o*_+f*S+m*b,L=a*O+u*_+d*S+y*b,B=i*O+l*_+h*S+v*b,W=s*O+c*_+p*S+w*b,j=r*M+o*A+f*R+m*T,k=a*M+u*A+d*R+y*T,Y=i*M+l*A+h*R+v*T,Z=s*M+c*A+p*R+w*T,H=r*z+o*q+f*I+m*P,J=a*z+u*q+d*I+y*P,X=i*z+l*q+h*I+v*P,G=s*z+c*q+p*I+w*P;return n[0]=D,n[1]=N,n[2]=U,n[3]=F,n[4]=V,n[5]=L,n[6]=B,n[7]=W,n[8]=j,n[9]=k,n[10]=Y,n[11]=Z,n[12]=H,n[13]=J,n[14]=X,n[15]=G,n},Q.add=function(e,t,n){return n[0]=e[0]+t[0],n[1]=e[1]+t[1],n[2]=e[2]+t[2],n[3]=e[3]+t[3],n[4]=e[4]+t[4],n[5]=e[5]+t[5],n[6]=e[6]+t[6],n[7]=e[7]+t[7],n[8]=e[8]+t[8],n[9]=e[9]+t[9],n[10]=e[10]+t[10],n[11]=e[11]+t[11],n[12]=e[12]+t[12],n[13]=e[13]+t[13],n[14]=e[14]+t[14],n[15]=e[15]+t[15],n},Q.subtract=function(e,t,n){return n[0]=e[0]-t[0],n[1]=e[1]-t[1],n[2]=e[2]-t[2],n[3]=e[3]-t[3],n[4]=e[4]-t[4],n[5]=e[5]-t[5],n[6]=e[6]-t[6],n[7]=e[7]-t[7],n[8]=e[8]-t[8],n[9]=e[9]-t[9],n[10]=e[10]-t[10],n[11]=e[11]-t[11],n[12]=e[12]-t[12],n[13]=e[13]-t[13],n[14]=e[14]-t[14],n[15]=e[15]-t[15],n},Q.multiplyTransformation=function(e,t,n){var r=e[0],a=e[1],i=e[2],s=e[4],o=e[5],u=e[6],l=e[8],c=e[9],f=e[10],d=e[12],h=e[13],p=e[14],m=t[0],y=t[1],v=t[2],w=t[4],C=t[5],g=t[6],x=t[8],E=t[9],O=t[10],_=t[12],S=t[13],b=t[14],M=r*m+s*y+l*v,A=a*m+o*y+c*v,R=i*m+u*y+f*v,T=r*w+s*C+l*g,z=a*w+o*C+c*g,q=i*w+u*C+f*g,I=r*x+s*E+l*O,P=a*x+o*E+c*O,D=i*x+u*E+f*O,N=r*_+s*S+l*b+d,U=a*_+o*S+c*b+h,F=i*_+u*S+f*b+p;return n[0]=M,n[1]=A,n[2]=R,n[3]=0,n[4]=T,n[5]=z,n[6]=q,n[7]=0,n[8]=I,n[9]=P,n[10]=D,n[11]=0,n[12]=N,n[13]=U,n[14]=F,n[15]=1,n},Q.multiplyByMatrix3=function(e,t,n){var r=e[0],a=e[1],i=e[2],s=e[4],o=e[5],u=e[6],l=e[8],c=e[9],f=e[10],d=t[0],h=t[1],p=t[2],m=t[3],y=t[4],v=t[5],w=t[6],C=t[7],g=t[8],x=r*d+s*h+l*p,E=a*d+o*h+c*p,O=i*d+u*h+f*p,_=r*m+s*y+l*v,S=a*m+o*y+c*v,b=i*m+u*y+f*v,M=r*w+s*C+l*g,A=a*w+o*C+c*g,R=i*w+u*C+f*g;return n[0]=x,n[1]=E,n[2]=O,n[3]=0,n[4]=_,n[5]=S,n[6]=b,n[7]=0,n[8]=M,n[9]=A,n[10]=R,n[11]=0,n[12]=e[12],n[13]=e[13],n[14]=e[14],n[15]=e[15],n},Q.multiplyByTranslation=function(e,t,n){var r=t.x,a=t.y,i=t.z,s=r*e[0]+a*e[4]+i*e[8]+e[12],o=r*e[1]+a*e[5]+i*e[9]+e[13],u=r*e[2]+a*e[6]+i*e[10]+e[14];return n[0]=e[0],n[1]=e[1],n[2]=e[2],n[3]=e[3],n[4]=e[4],n[5]=e[5],n[6]=e[6],n[7]=e[7],n[8]=e[8],n[9]=e[9],n[10]=e[10],n[11]=e[11],n[12]=s,n[13]=o,n[14]=u,n[15]=e[15],n};var A=new D.Cartesian3;Q.multiplyByUniformScale=function(e,t,n){return A.x=t,A.y=t,A.z=t,Q.multiplyByScale(e,A,n)},Q.multiplyByScale=function(e,t,n){var r=t.x,a=t.y,i=t.z;return 1===r&&1===a&&1===i?Q.clone(e,n):(n[0]=r*e[0],n[1]=r*e[1],n[2]=r*e[2],n[3]=0,n[4]=a*e[4],n[5]=a*e[5],n[6]=a*e[6],n[7]=0,n[8]=i*e[8],n[9]=i*e[9],n[10]=i*e[10],n[11]=0,n[12]=e[12],n[13]=e[13],n[14]=e[14],n[15]=1,n)},Q.multiplyByVector=function(e,t,n){var r=t.x,a=t.y,i=t.z,s=t.w,o=e[0]*r+e[4]*a+e[8]*i+e[12]*s,u=e[1]*r+e[5]*a+e[9]*i+e[13]*s,l=e[2]*r+e[6]*a+e[10]*i+e[14]*s,c=e[3]*r+e[7]*a+e[11]*i+e[15]*s;return n.x=o,n.y=u,n.z=l,n.w=c,n},Q.multiplyByPointAsVector=function(e,t,n){var r=t.x,a=t.y,i=t.z,s=e[0]*r+e[4]*a+e[8]*i,o=e[1]*r+e[5]*a+e[9]*i,u=e[2]*r+e[6]*a+e[10]*i;return n.x=s,n.y=o,n.z=u,n},Q.multiplyByPoint=function(e,t,n){var r=t.x,a=t.y,i=t.z,s=e[0]*r+e[4]*a+e[8]*i+e[12],o=e[1]*r+e[5]*a+e[9]*i+e[13],u=e[2]*r+e[6]*a+e[10]*i+e[14];return n.x=s,n.y=o,n.z=u,n},Q.multiplyByScalar=function(e,t,n){return n[0]=e[0]*t,n[1]=e[1]*t,n[2]=e[2]*t,n[3]=e[3]*t,n[4]=e[4]*t,n[5]=e[5]*t,n[6]=e[6]*t,n[7]=e[7]*t,n[8]=e[8]*t,n[9]=e[9]*t,n[10]=e[10]*t,n[11]=e[11]*t,n[12]=e[12]*t,n[13]=e[13]*t,n[14]=e[14]*t,n[15]=e[15]*t,n},Q.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=-e[7],t[8]=-e[8],t[9]=-e[9],t[10]=-e[10],t[11]=-e[11],t[12]=-e[12],t[13]=-e[13],t[14]=-e[14],t[15]=-e[15],t},Q.transpose=function(e,t){var n=e[1],r=e[2],a=e[3],i=e[6],s=e[7],o=e[11];return t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=n,t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=r,t[9]=i,t[10]=e[10],t[11]=e[14],t[12]=a,t[13]=s,t[14]=o,t[15]=e[15],t},Q.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t[4]=Math.abs(e[4]),t[5]=Math.abs(e[5]),t[6]=Math.abs(e[6]),t[7]=Math.abs(e[7]),t[8]=Math.abs(e[8]),t[9]=Math.abs(e[9]),t[10]=Math.abs(e[10]),t[11]=Math.abs(e[11]),t[12]=Math.abs(e[12]),t[13]=Math.abs(e[13]),t[14]=Math.abs(e[14]),t[15]=Math.abs(e[15]),t},Q.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[3]===t[3]&&e[7]===t[7]&&e[11]===t[11]&&e[15]===t[15]},Q.equalsEpsilon=function(e,t,n){return e===t||I.defined(e)&&I.defined(t)&&Math.abs(e[0]-t[0])<=n&&Math.abs(e[1]-t[1])<=n&&Math.abs(e[2]-t[2])<=n&&Math.abs(e[3]-t[3])<=n&&Math.abs(e[4]-t[4])<=n&&Math.abs(e[5]-t[5])<=n&&Math.abs(e[6]-t[6])<=n&&Math.abs(e[7]-t[7])<=n&&Math.abs(e[8]-t[8])<=n&&Math.abs(e[9]-t[9])<=n&&Math.abs(e[10]-t[10])<=n&&Math.abs(e[11]-t[11])<=n&&Math.abs(e[12]-t[12])<=n&&Math.abs(e[13]-t[13])<=n&&Math.abs(e[14]-t[14])<=n&&Math.abs(e[15]-t[15])<=n},Q.getTranslation=function(e,t){return t.x=e[12],t.y=e[13],t.z=e[14],t},Q.getMatrix3=function(e,t){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t};var K=new X,$=new X,ee=new G,te=new G(0,0,0,1);function N(e,t){this.center=D.Cartesian3.clone(P.defaultValue(e,D.Cartesian3.ZERO)),this.radius=P.defaultValue(t,0)}Q.inverse=function(e,t){var n=e[0],r=e[4],a=e[8],i=e[12],s=e[1],o=e[5],u=e[9],l=e[13],c=e[2],f=e[6],d=e[10],h=e[14],p=e[3],m=e[7],y=e[11],v=e[15],w=d*v,C=h*y,g=f*v,x=h*m,E=f*y,O=d*m,_=c*v,S=h*p,b=c*y,M=d*p,A=c*m,R=f*p,T=w*o+x*u+E*l-(C*o+g*u+O*l),z=C*s+_*u+M*l-(w*s+S*u+b*l),q=g*s+S*o+A*l-(x*s+_*o+R*l),I=O*s+b*o+R*u-(E*s+M*o+A*u),P=C*r+g*a+O*i-(w*r+x*a+E*i),D=w*n+S*a+b*i-(C*n+_*a+M*i),N=x*n+_*r+R*i-(g*n+S*r+A*i),U=E*n+M*r+A*a-(O*n+b*r+R*a),F=(w=a*l)*m+(x=i*o)*y+(E=r*u)*v-((C=i*u)*m+(g=r*l)*y+(O=a*o)*v),V=C*p+(_=n*l)*y+(M=a*s)*v-(w*p+(S=i*s)*y+(b=n*u)*v),L=g*p+S*m+(A=n*o)*v-(x*p+_*m+(R=r*s)*v),B=O*p+b*m+R*y-(E*p+M*m+A*y),W=g*d+O*h+C*f-(E*h+w*f+x*d),j=b*h+w*c+S*d-(_*d+M*h+C*c),k=_*f+R*h+x*c-(A*h+g*c+S*f),Y=A*d+E*c+M*f-(b*f+R*d+O*c),Z=n*T+r*z+a*q+i*I;if(Math.abs(Z)<H.CesiumMath.EPSILON21){if(X.equalsEpsilon(Q.getMatrix3(e,K),$,H.CesiumMath.EPSILON7)&&G.equals(Q.getRow(e,3,ee),te))return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=0,t[11]=0,t[12]=-e[12],t[13]=-e[13],t[14]=-e[14],t[15]=1,t;throw new J.RuntimeError("matrix is not invertible because its determinate is zero.")}return Z=1/Z,t[0]=T*Z,t[1]=z*Z,t[2]=q*Z,t[3]=I*Z,t[4]=P*Z,t[5]=D*Z,t[6]=N*Z,t[7]=U*Z,t[8]=F*Z,t[9]=V*Z,t[10]=L*Z,t[11]=B*Z,t[12]=W*Z,t[13]=j*Z,t[14]=k*Z,t[15]=Y*Z,t},Q.inverseTransformation=function(e,t){var n=e[0],r=e[1],a=e[2],i=e[4],s=e[5],o=e[6],u=e[8],l=e[9],c=e[10],f=e[12],d=e[13],h=e[14],p=-n*f-r*d-a*h,m=-i*f-s*d-o*h,y=-u*f-l*d-c*h;return t[0]=n,t[1]=i,t[2]=u,t[3]=0,t[4]=r,t[5]=s,t[6]=l,t[7]=0,t[8]=a,t[9]=o,t[10]=c,t[11]=0,t[12]=p,t[13]=m,t[14]=y,t[15]=1,t},Q.IDENTITY=t.freezeObject(new Q(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)),Q.ZERO=t.freezeObject(new Q(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)),Q.COLUMN0ROW0=0,Q.COLUMN0ROW1=1,Q.COLUMN0ROW2=2,Q.COLUMN0ROW3=3,Q.COLUMN1ROW0=4,Q.COLUMN1ROW1=5,Q.COLUMN1ROW2=6,Q.COLUMN1ROW3=7,Q.COLUMN2ROW0=8,Q.COLUMN2ROW1=9,Q.COLUMN2ROW2=10,Q.COLUMN2ROW3=11,Q.COLUMN3ROW0=12,Q.COLUMN3ROW1=13,Q.COLUMN3ROW2=14,Q.COLUMN3ROW3=15,r.defineProperties(Q.prototype,{length:{get:function(){return Q.packedLength}}}),Q.prototype.clone=function(e){return Q.clone(this,e)},Q.prototype.equals=function(e){return Q.equals(this,e)},Q.equalsArray=function(e,t,n){return e[0]===t[n]&&e[1]===t[n+1]&&e[2]===t[n+2]&&e[3]===t[n+3]&&e[4]===t[n+4]&&e[5]===t[n+5]&&e[6]===t[n+6]&&e[7]===t[n+7]&&e[8]===t[n+8]&&e[9]===t[n+9]&&e[10]===t[n+10]&&e[11]===t[n+11]&&e[12]===t[n+12]&&e[13]===t[n+13]&&e[14]===t[n+14]&&e[15]===t[n+15]},Q.prototype.equalsEpsilon=function(e,t){return Q.equalsEpsilon(this,e,t)},Q.prototype.toString=function(){return"("+this[0]+", "+this[4]+", "+this[8]+", "+this[12]+")\n("+this[1]+", "+this[5]+", "+this[9]+", "+this[13]+")\n("+this[2]+", "+this[6]+", "+this[10]+", "+this[14]+")\n("+this[3]+", "+this[7]+", "+this[11]+", "+this[15]+")"};var U=new D.Cartesian3,F=new D.Cartesian3,V=new D.Cartesian3,L=new D.Cartesian3,B=new D.Cartesian3,W=new D.Cartesian3,j=new D.Cartesian3,k=new D.Cartesian3,Y=new D.Cartesian3,Z=new D.Cartesian3,ne=new D.Cartesian3,re=new D.Cartesian3,R=4/3*H.CesiumMath.PI;N.fromPoints=function(e,t){if(I.defined(t)||(t=new N),!I.defined(e)||0===e.length)return t.center=D.Cartesian3.clone(D.Cartesian3.ZERO,t.center),t.radius=0,t;var n,r=D.Cartesian3.clone(e[0],j),a=D.Cartesian3.clone(r,U),i=D.Cartesian3.clone(r,F),s=D.Cartesian3.clone(r,V),o=D.Cartesian3.clone(r,L),u=D.Cartesian3.clone(r,B),l=D.Cartesian3.clone(r,W),c=e.length;for(n=1;n<c;n++){D.Cartesian3.clone(e[n],r);var f=r.x,d=r.y,h=r.z;f<a.x&&D.Cartesian3.clone(r,a),f>o.x&&D.Cartesian3.clone(r,o),d<i.y&&D.Cartesian3.clone(r,i),d>u.y&&D.Cartesian3.clone(r,u),h<s.z&&D.Cartesian3.clone(r,s),h>l.z&&D.Cartesian3.clone(r,l)}var p=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(o,a,k)),m=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(u,i,k)),y=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(l,s,k)),v=a,w=o,C=p;C<m&&(C=m,v=i,w=u),C<y&&(C=y,v=s,w=l);var g=Y;g.x=.5*(v.x+w.x),g.y=.5*(v.y+w.y),g.z=.5*(v.z+w.z);var x=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(w,g,k)),E=Math.sqrt(x),O=Z;O.x=a.x,O.y=i.y,O.z=s.z;var _=ne;_.x=o.x,_.y=u.y,_.z=l.z;var S=D.Cartesian3.midpoint(O,_,re),b=0;for(n=0;n<c;n++){D.Cartesian3.clone(e[n],r);var M=D.Cartesian3.magnitude(D.Cartesian3.subtract(r,S,k));b<M&&(b=M);var A=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(r,g,k));if(x<A){var R=Math.sqrt(A);x=(E=.5*(E+R))*E;var T=R-E;g.x=(E*g.x+T*r.x)/R,g.y=(E*g.y+T*r.y)/R,g.z=(E*g.z+T*r.z)/R}}return E<b?(D.Cartesian3.clone(g,t.center),t.radius=E):(D.Cartesian3.clone(S,t.center),t.radius=b),t};var T=new a,z=new D.Cartesian3,q=new D.Cartesian3,ae=new D.Cartographic,ie=new D.Cartographic;N.fromRectangle2D=function(e,t,n){return N.fromRectangleWithHeights2D(e,t,0,0,n)},N.fromRectangleWithHeights2D=function(e,t,n,r,a){if(I.defined(a)||(a=new N),!I.defined(e))return a.center=D.Cartesian3.clone(D.Cartesian3.ZERO,a.center),a.radius=0,a;t=P.defaultValue(t,T),D.Rectangle.southwest(e,ae),ae.height=n,D.Rectangle.northeast(e,ie),ie.height=r;var i=t.project(ae,z),s=t.project(ie,q),o=s.x-i.x,u=s.y-i.y,l=s.z-i.z;a.radius=.5*Math.sqrt(o*o+u*u+l*l);var c=a.center;return c.x=i.x+.5*o,c.y=i.y+.5*u,c.z=i.z+.5*l,a};var se=[];N.fromRectangle3D=function(e,t,n,r){if(t=P.defaultValue(t,D.Ellipsoid.WGS84),n=P.defaultValue(n,0),I.defined(r)||(r=new N),!I.defined(e))return r.center=D.Cartesian3.clone(D.Cartesian3.ZERO,r.center),r.radius=0,r;var a=D.Rectangle.subsample(e,t,n,se);return N.fromPoints(a,r)},N.fromVertices=function(e,t,n,r){if(I.defined(r)||(r=new N),!I.defined(e)||0===e.length)return r.center=D.Cartesian3.clone(D.Cartesian3.ZERO,r.center),r.radius=0,r;t=P.defaultValue(t,D.Cartesian3.ZERO),n=P.defaultValue(n,3);var a=j;a.x=e[0]+t.x,a.y=e[1]+t.y,a.z=e[2]+t.z;var i,s=D.Cartesian3.clone(a,U),o=D.Cartesian3.clone(a,F),u=D.Cartesian3.clone(a,V),l=D.Cartesian3.clone(a,L),c=D.Cartesian3.clone(a,B),f=D.Cartesian3.clone(a,W),d=e.length;for(i=0;i<d;i+=n){var h=e[i]+t.x,p=e[i+1]+t.y,m=e[i+2]+t.z;a.x=h,a.y=p,a.z=m,h<s.x&&D.Cartesian3.clone(a,s),h>l.x&&D.Cartesian3.clone(a,l),p<o.y&&D.Cartesian3.clone(a,o),p>c.y&&D.Cartesian3.clone(a,c),m<u.z&&D.Cartesian3.clone(a,u),m>f.z&&D.Cartesian3.clone(a,f)}var y=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(l,s,k)),v=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(c,o,k)),w=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(f,u,k)),C=s,g=l,x=y;x<v&&(x=v,C=o,g=c),x<w&&(x=w,C=u,g=f);var E=Y;E.x=.5*(C.x+g.x),E.y=.5*(C.y+g.y),E.z=.5*(C.z+g.z);var O=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(g,E,k)),_=Math.sqrt(O),S=Z;S.x=s.x,S.y=o.y,S.z=u.z;var b=ne;b.x=l.x,b.y=c.y,b.z=f.z;var M=D.Cartesian3.midpoint(S,b,re),A=0;for(i=0;i<d;i+=n){a.x=e[i]+t.x,a.y=e[i+1]+t.y,a.z=e[i+2]+t.z;var R=D.Cartesian3.magnitude(D.Cartesian3.subtract(a,M,k));A<R&&(A=R);var T=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(a,E,k));if(O<T){var z=Math.sqrt(T);O=(_=.5*(_+z))*_;var q=z-_;E.x=(_*E.x+q*a.x)/z,E.y=(_*E.y+q*a.y)/z,E.z=(_*E.z+q*a.z)/z}}return _<A?(D.Cartesian3.clone(E,r.center),r.radius=_):(D.Cartesian3.clone(M,r.center),r.radius=A),r},N.fromEncodedCartesianVertices=function(e,t,n){if(I.defined(n)||(n=new N),!I.defined(e)||!I.defined(t)||e.length!==t.length||0===e.length)return n.center=D.Cartesian3.clone(D.Cartesian3.ZERO,n.center),n.radius=0,n;var r=j;r.x=e[0]+t[0],r.y=e[1]+t[1],r.z=e[2]+t[2];var a,i=D.Cartesian3.clone(r,U),s=D.Cartesian3.clone(r,F),o=D.Cartesian3.clone(r,V),u=D.Cartesian3.clone(r,L),l=D.Cartesian3.clone(r,B),c=D.Cartesian3.clone(r,W),f=e.length;for(a=0;a<f;a+=3){var d=e[a]+t[a],h=e[a+1]+t[a+1],p=e[a+2]+t[a+2];r.x=d,r.y=h,r.z=p,d<i.x&&D.Cartesian3.clone(r,i),d>u.x&&D.Cartesian3.clone(r,u),h<s.y&&D.Cartesian3.clone(r,s),h>l.y&&D.Cartesian3.clone(r,l),p<o.z&&D.Cartesian3.clone(r,o),p>c.z&&D.Cartesian3.clone(r,c)}var m=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(u,i,k)),y=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(l,s,k)),v=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(c,o,k)),w=i,C=u,g=m;g<y&&(g=y,w=s,C=l),g<v&&(g=v,w=o,C=c);var x=Y;x.x=.5*(w.x+C.x),x.y=.5*(w.y+C.y),x.z=.5*(w.z+C.z);var E=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(C,x,k)),O=Math.sqrt(E),_=Z;_.x=i.x,_.y=s.y,_.z=o.z;var S=ne;S.x=u.x,S.y=l.y,S.z=c.z;var b=D.Cartesian3.midpoint(_,S,re),M=0;for(a=0;a<f;a+=3){r.x=e[a]+t[a],r.y=e[a+1]+t[a+1],r.z=e[a+2]+t[a+2];var A=D.Cartesian3.magnitude(D.Cartesian3.subtract(r,b,k));M<A&&(M=A);var R=D.Cartesian3.magnitudeSquared(D.Cartesian3.subtract(r,x,k));if(E<R){var T=Math.sqrt(R);E=(O=.5*(O+T))*O;var z=T-O;x.x=(O*x.x+z*r.x)/T,x.y=(O*x.y+z*r.y)/T,x.z=(O*x.z+z*r.z)/T}}return O<M?(D.Cartesian3.clone(x,n.center),n.radius=O):(D.Cartesian3.clone(b,n.center),n.radius=M),n},N.fromCornerPoints=function(e,t,n){I.defined(n)||(n=new N);var r=D.Cartesian3.midpoint(e,t,n.center);return n.radius=D.Cartesian3.distance(r,t),n},N.fromEllipsoid=function(e,t){return I.defined(t)||(t=new N),D.Cartesian3.clone(D.Cartesian3.ZERO,t.center),t.radius=e.maximumRadius,t};var oe=new D.Cartesian3;N.fromBoundingSpheres=function(e,t){if(I.defined(t)||(t=new N),!I.defined(e)||0===e.length)return t.center=D.Cartesian3.clone(D.Cartesian3.ZERO,t.center),t.radius=0,t;var n=e.length;if(1===n)return N.clone(e[0],t);if(2===n)return N.union(e[0],e[1],t);var r,a=[];for(r=0;r<n;r++)a.push(e[r].center);var i=(t=N.fromPoints(a,t)).center,s=t.radius;for(r=0;r<n;r++){var o=e[r];s=Math.max(s,D.Cartesian3.distance(i,o.center,oe)+o.radius)}return t.radius=s,t};var ue=new D.Cartesian3,le=new D.Cartesian3,ce=new D.Cartesian3;N.fromOrientedBoundingBox=function(e,t){I.defined(t)||(t=new N);var n=e.halfAxes,r=X.getColumn(n,0,ue),a=X.getColumn(n,1,le),i=X.getColumn(n,2,ce);return D.Cartesian3.add(r,a,r),D.Cartesian3.add(r,i,r),t.center=D.Cartesian3.clone(e.center,t.center),t.radius=D.Cartesian3.magnitude(r),t},N.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t.center=D.Cartesian3.clone(e.center,t.center),t.radius=e.radius,t):new N(e.center,e.radius)},N.packedLength=4,N.pack=function(e,t,n){n=P.defaultValue(n,0);var r=e.center;return t[n++]=r.x,t[n++]=r.y,t[n++]=r.z,t[n]=e.radius,t},N.unpack=function(e,t,n){t=P.defaultValue(t,0),I.defined(n)||(n=new N);var r=n.center;return r.x=e[t++],r.y=e[t++],r.z=e[t++],n.radius=e[t],n};var fe=new D.Cartesian3,de=new D.Cartesian3;N.union=function(e,t,n){I.defined(n)||(n=new N);var r=e.center,a=e.radius,i=t.center,s=t.radius,o=D.Cartesian3.subtract(i,r,fe),u=D.Cartesian3.magnitude(o);if(u+s<=a)return e.clone(n),n;if(u+a<=s)return t.clone(n),n;var l=.5*(a+u+s),c=D.Cartesian3.multiplyByScalar(o,(l-a)/u,de);return D.Cartesian3.add(c,r,c),D.Cartesian3.clone(c,n.center),n.radius=l,n};var he=new D.Cartesian3;N.expand=function(e,t,n){n=N.clone(e,n);var r=D.Cartesian3.magnitude(D.Cartesian3.subtract(t,n.center,he));return r>n.radius&&(n.radius=r),n},N.intersectPlane=function(e,t){var n=e.center,r=e.radius,a=t.normal,i=D.Cartesian3.dot(a,n)+t.distance;return i<-r?s.OUTSIDE:i<r?s.INTERSECTING:s.INSIDE},N.transform=function(e,t,n){return I.defined(n)||(n=new N),n.center=Q.multiplyByPoint(t,e.center,n.center),n.radius=Q.getMaximumScale(t)*e.radius,n};var pe=new D.Cartesian3;N.distanceSquaredTo=function(e,t){var n=D.Cartesian3.subtract(e.center,t,pe);return D.Cartesian3.magnitudeSquared(n)-e.radius*e.radius},N.transformWithoutScale=function(e,t,n){return I.defined(n)||(n=new N),n.center=Q.multiplyByPoint(t,e.center,n.center),n.radius=e.radius,n};var me=new D.Cartesian3;N.computePlaneDistances=function(e,t,n,r){I.defined(r)||(r=new o);var a=D.Cartesian3.subtract(e.center,t,me),i=D.Cartesian3.dot(n,a);return r.start=i-e.radius,r.stop=i+e.radius,r};for(var ye=new D.Cartesian3,ve=new D.Cartesian3,we=new D.Cartesian3,Ce=new D.Cartesian3,ge=new D.Cartesian3,xe=new D.Cartographic,Ee=new Array(8),Oe=0;Oe<8;++Oe)Ee[Oe]=new D.Cartesian3;var _e,Se=new a;N.projectTo2D=function(e,t,n){var r=(t=P.defaultValue(t,Se)).ellipsoid,a=e.center,i=e.radius,s=r.geodeticSurfaceNormal(a,ye),o=D.Cartesian3.cross(D.Cartesian3.UNIT_Z,s,ve);D.Cartesian3.normalize(o,o);var u=D.Cartesian3.cross(s,o,we);D.Cartesian3.normalize(u,u),D.Cartesian3.multiplyByScalar(s,i,s),D.Cartesian3.multiplyByScalar(u,i,u),D.Cartesian3.multiplyByScalar(o,i,o);var l=D.Cartesian3.negate(u,ge),c=D.Cartesian3.negate(o,Ce),f=Ee,d=f[0];D.Cartesian3.add(s,u,d),D.Cartesian3.add(d,o,d),d=f[1],D.Cartesian3.add(s,u,d),D.Cartesian3.add(d,c,d),d=f[2],D.Cartesian3.add(s,l,d),D.Cartesian3.add(d,c,d),d=f[3],D.Cartesian3.add(s,l,d),D.Cartesian3.add(d,o,d),D.Cartesian3.negate(s,s),d=f[4],D.Cartesian3.add(s,u,d),D.Cartesian3.add(d,o,d),d=f[5],D.Cartesian3.add(s,u,d),D.Cartesian3.add(d,c,d),d=f[6],D.Cartesian3.add(s,l,d),D.Cartesian3.add(d,c,d),d=f[7],D.Cartesian3.add(s,l,d),D.Cartesian3.add(d,o,d);for(var h=f.length,p=0;p<h;++p){var m=f[p];D.Cartesian3.add(a,m,m);var y=r.cartesianToCartographic(m,xe);t.project(y,m)}var v=(a=(n=N.fromPoints(f,n)).center).x,w=a.y,C=a.z;return a.x=C,a.y=v,a.z=w,n},N.isOccluded=function(e,t){return!t.isBoundingSphereVisible(e)},N.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&D.Cartesian3.equals(e.center,t.center)&&e.radius===t.radius},N.prototype.intersectPlane=function(e){return N.intersectPlane(this,e)},N.prototype.distanceSquaredTo=function(e){return N.distanceSquaredTo(this,e)},N.prototype.computePlaneDistances=function(e,t,n){return N.computePlaneDistances(this,e,t,n)},N.prototype.isOccluded=function(e){return N.isOccluded(this,e)},N.prototype.equals=function(e){return N.equals(this,e)},N.prototype.clone=function(e){return N.clone(this,e)},N.prototype.volume=function(){var e=this.radius;return R*e*e*e};var be,Me,Ae,Re,Te,ze,qe,Ie,Pe,De,Ne,Ue,Fe,Ve,Le,Be,We,je={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},ke={};function Ye(e){for(var t=e.split("."),n=0,r=t.length;n<r;++n)t[n]=parseInt(t[n],10);return t}function Ze(){if(!I.defined(Me)&&(Me=!1,!Ge())){var e=/ Chrome\/([\.0-9]+)/.exec(be.userAgent);null!==e&&(Me=!0,Ae=Ye(e[1]))}return Me}function He(){if(!I.defined(Re)&&(Re=!1,!Ze()&&!Ge()&&/ Safari\/[\.0-9]+/.test(be.userAgent))){var e=/ Version\/([\.0-9]+)/.exec(be.userAgent);null!==e&&(Re=!0,Te=Ye(e[1]))}return Re}function Je(){if(!I.defined(ze)){ze=!1;var e=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(be.userAgent);null!==e&&(ze=!0,(qe=Ye(e[1])).isNightly=!!e[2])}return ze}function Xe(){var e;I.defined(Ie)||(Ie=!1,"Microsoft Internet Explorer"===be.appName?null!==(e=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(be.userAgent))&&(Ie=!0,Pe=Ye(e[1])):"Netscape"===be.appName&&null!==(e=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(be.userAgent))&&(Ie=!0,Pe=Ye(e[1])));return Ie}function Ge(){if(!I.defined(De)){De=!1;var e=/ Edge\/([\.0-9]+)/.exec(be.userAgent);null!==e&&(De=!0,Ne=Ye(e[1]))}return De}function Qe(){if(!I.defined(Ue)){Ue=!1;var e=/Firefox\/([\.0-9]+)/.exec(be.userAgent);null!==e&&(Ue=!0,Fe=Ye(e[1]))}return Ue}function Ke(){if(!I.defined(We)){var e=document.createElement("canvas");e.setAttribute("style","image-rendering: -moz-crisp-edges;image-rendering: pixelated;");var t=e.style.imageRendering;(We=I.defined(t)&&""!==t)&&(Be=t)}return We}function $e(){return $e._result}r.defineProperties(ke,{element:{get:function(){if(ke.supportsFullscreen())return document[je.fullscreenElement]}},changeEventName:{get:function(){if(ke.supportsFullscreen())return je.fullscreenchange}},errorEventName:{get:function(){if(ke.supportsFullscreen())return je.fullscreenerror}},enabled:{get:function(){if(ke.supportsFullscreen())return document[je.fullscreenEnabled]}},fullscreen:{get:function(){if(ke.supportsFullscreen())return null!==ke.element}}}),ke.supportsFullscreen=function(){if(I.defined(_e))return _e;_e=!1;var e=document.body;if("function"==typeof e.requestFullscreen)return je.requestFullscreen="requestFullscreen",je.exitFullscreen="exitFullscreen",je.fullscreenEnabled="fullscreenEnabled",je.fullscreenElement="fullscreenElement",je.fullscreenchange="fullscreenchange",je.fullscreenerror="fullscreenerror",_e=!0;for(var t,n=["webkit","moz","o","ms","khtml"],r=0,a=n.length;r<a;++r){var i=n[r];"function"==typeof e[t=i+"RequestFullscreen"]?(je.requestFullscreen=t,_e=!0):"function"==typeof e[t=i+"RequestFullScreen"]&&(je.requestFullscreen=t,_e=!0),t=i+"ExitFullscreen","function"==typeof document[t]?je.exitFullscreen=t:(t=i+"CancelFullScreen","function"==typeof document[t]&&(je.exitFullscreen=t)),t=i+"FullscreenEnabled",void 0!==document[t]?je.fullscreenEnabled=t:(t=i+"FullScreenEnabled",void 0!==document[t]&&(je.fullscreenEnabled=t)),t=i+"FullscreenElement",void 0!==document[t]?je.fullscreenElement=t:(t=i+"FullScreenElement",void 0!==document[t]&&(je.fullscreenElement=t)),t=i+"fullscreenchange",void 0!==document["on"+t]&&("ms"===i&&(t="MSFullscreenChange"),je.fullscreenchange=t),t=i+"fullscreenerror",void 0!==document["on"+t]&&("ms"===i&&(t="MSFullscreenError"),je.fullscreenerror=t)}return _e},ke.requestFullscreen=function(e,t){ke.supportsFullscreen()&&e[je.requestFullscreen]({vrDisplay:t})},ke.exitFullscreen=function(){ke.supportsFullscreen()&&document[je.exitFullscreen]()},ke._names=je,be="undefined"!=typeof navigator?navigator:{},$e._promise=void 0,$e._result=void 0,$e.initialize=function(){if(I.defined($e._promise))return $e._promise;var e=d.when.defer();if($e._promise=e.promise,Ge())return $e._result=!1,e.resolve($e._result),e.promise;var t=new Image;return t.onload=function(){$e._result=0<t.width&&0<t.height,e.resolve($e._result)},t.onerror=function(){$e._result=!1,e.resolve($e._result)},t.src="data:image/webp;base64,UklGRiIAAABXRUJQVlA4IBYAAAAwAQCdASoBAAEADsD+JaQAA3AAAAAA",e.promise},r.defineProperties($e,{initialized:{get:function(){return I.defined($e._result)}}});var et=[];"undefined"!=typeof ArrayBuffer&&(et.push(Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array),"undefined"!=typeof Uint8ClampedArray&&et.push(Uint8ClampedArray),"undefined"!=typeof CanvasPixelArray&&et.push(CanvasPixelArray));var tt={isChrome:Ze,chromeVersion:function(){return Ze()&&Ae},isSafari:He,safariVersion:function(){return He()&&Te},isWebkit:Je,webkitVersion:function(){return Je()&&qe},isInternetExplorer:Xe,internetExplorerVersion:function(){return Xe()&&Pe},isEdge:Ge,edgeVersion:function(){return Ge()&&Ne},isFirefox:Qe,firefoxVersion:function(){return Qe()&&Fe},isWindows:function(){return I.defined(Ve)||(Ve=/Windows/i.test(be.appVersion)),Ve},hardwareConcurrency:P.defaultValue(be.hardwareConcurrency,3),supportsPointerEvents:function(){return I.defined(Le)||(Le=!Qe()&&"undefined"!=typeof PointerEvent&&(!I.defined(be.pointerEnabled)||be.pointerEnabled)),Le},supportsImageRenderingPixelated:Ke,supportsWebP:$e,imageRenderingValue:function(){return Ke()?Be:void 0},typedArrayTypes:et};function nt(e,t,n,r){this.x=P.defaultValue(e,0),this.y=P.defaultValue(t,0),this.z=P.defaultValue(n,0),this.w=P.defaultValue(r,0)}tt.supportsFullscreen=function(){return ke.supportsFullscreen()},tt.supportsTypedArrays=function(){return"undefined"!=typeof ArrayBuffer},tt.supportsWebWorkers=function(){return"undefined"!=typeof Worker},tt.supportsWebAssembly=function(){return"undefined"!=typeof WebAssembly&&!tt.isEdge()};var rt=new D.Cartesian3;nt.fromAxisAngle=function(e,t,n){var r=t/2,a=Math.sin(r),i=(rt=D.Cartesian3.normalize(e,rt)).x*a,s=rt.y*a,o=rt.z*a,u=Math.cos(r);return I.defined(n)?(n.x=i,n.y=s,n.z=o,n.w=u,n):new nt(i,s,o,u)};var at=[1,2,0],it=new Array(3);nt.fromRotationMatrix=function(e,t){var n,r,a,i,s,o=e[X.COLUMN0ROW0],u=e[X.COLUMN1ROW1],l=e[X.COLUMN2ROW2],c=o+u+l;if(0<c)s=.5*(n=Math.sqrt(c+1)),n=.5/n,r=(e[X.COLUMN1ROW2]-e[X.COLUMN2ROW1])*n,a=(e[X.COLUMN2ROW0]-e[X.COLUMN0ROW2])*n,i=(e[X.COLUMN0ROW1]-e[X.COLUMN1ROW0])*n;else{var f=0;o<u&&(f=1),o<l&&u<l&&(f=2);var d=at[f],h=at[d];n=Math.sqrt(e[X.getElementIndex(f,f)]-e[X.getElementIndex(d,d)]-e[X.getElementIndex(h,h)]+1);var p=it;p[f]=.5*n,n=.5/n,s=(e[X.getElementIndex(h,d)]-e[X.getElementIndex(d,h)])*n,p[d]=(e[X.getElementIndex(d,f)]+e[X.getElementIndex(f,d)])*n,p[h]=(e[X.getElementIndex(h,f)]+e[X.getElementIndex(f,h)])*n,r=-p[0],a=-p[1],i=-p[2]}return I.defined(t)?(t.x=r,t.y=a,t.z=i,t.w=s,t):new nt(r,a,i,s)};var st=new nt,ot=new nt,ut=new nt,lt=new nt;nt.fromHeadingPitchRoll=function(e,t){return lt=nt.fromAxisAngle(D.Cartesian3.UNIT_X,e.roll,st),ut=nt.fromAxisAngle(D.Cartesian3.UNIT_Y,-e.pitch,t),t=nt.multiply(ut,lt,ut),ot=nt.fromAxisAngle(D.Cartesian3.UNIT_Z,-e.heading,st),nt.multiply(ot,t,t)};var ct=new D.Cartesian3,ft=new D.Cartesian3,dt=new nt,ht=new nt,pt=new nt;nt.packedLength=4,nt.pack=function(e,t,n){return n=P.defaultValue(n,0),t[n++]=e.x,t[n++]=e.y,t[n++]=e.z,t[n]=e.w,t},nt.unpack=function(e,t,n){return t=P.defaultValue(t,0),I.defined(n)||(n=new nt),n.x=e[t],n.y=e[t+1],n.z=e[t+2],n.w=e[t+3],n},nt.packedInterpolationLength=3,nt.convertPackedArrayForInterpolation=function(e,t,n,r){nt.unpack(e,4*n,pt),nt.conjugate(pt,pt);for(var a=0,i=n-t+1;a<i;a++){var s=3*a;nt.unpack(e,4*(t+a),dt),nt.multiply(dt,pt,dt),dt.w<0&&nt.negate(dt,dt),nt.computeAxis(dt,ct);var o=nt.computeAngle(dt);r[s]=ct.x*o,r[1+s]=ct.y*o,r[2+s]=ct.z*o}},nt.unpackInterpolationResult=function(e,t,n,r,a){I.defined(a)||(a=new nt),D.Cartesian3.fromArray(e,0,ft);var i=D.Cartesian3.magnitude(ft);return nt.unpack(t,4*r,ht),0===i?nt.clone(nt.IDENTITY,dt):nt.fromAxisAngle(ft,i,dt),nt.multiply(dt,ht,a)},nt.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t):new nt(e.x,e.y,e.z,e.w)},nt.conjugate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=e.w,t},nt.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z+e.w*e.w},nt.magnitude=function(e){return Math.sqrt(nt.magnitudeSquared(e))},nt.normalize=function(e,t){var n=1/nt.magnitude(e),r=e.x*n,a=e.y*n,i=e.z*n,s=e.w*n;return t.x=r,t.y=a,t.z=i,t.w=s,t},nt.inverse=function(e,t){var n=nt.magnitudeSquared(e);return t=nt.conjugate(e,t),nt.multiplyByScalar(t,1/n,t)},nt.add=function(e,t,n){return n.x=e.x+t.x,n.y=e.y+t.y,n.z=e.z+t.z,n.w=e.w+t.w,n},nt.subtract=function(e,t,n){return n.x=e.x-t.x,n.y=e.y-t.y,n.z=e.z-t.z,n.w=e.w-t.w,n},nt.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=-e.w,t},nt.dot=function(e,t){return e.x*t.x+e.y*t.y+e.z*t.z+e.w*t.w},nt.multiply=function(e,t,n){var r=e.x,a=e.y,i=e.z,s=e.w,o=t.x,u=t.y,l=t.z,c=t.w,f=s*o+r*c+a*l-i*u,d=s*u-r*l+a*c+i*o,h=s*l+r*u-a*o+i*c,p=s*c-r*o-a*u-i*l;return n.x=f,n.y=d,n.z=h,n.w=p,n},nt.multiplyByScalar=function(e,t,n){return n.x=e.x*t,n.y=e.y*t,n.z=e.z*t,n.w=e.w*t,n},nt.divideByScalar=function(e,t,n){return n.x=e.x/t,n.y=e.y/t,n.z=e.z/t,n.w=e.w/t,n},nt.computeAxis=function(e,t){var n=e.w;if(Math.abs(n-1)<H.CesiumMath.EPSILON6)return t.x=t.y=t.z=0,t;var r=1/Math.sqrt(1-n*n);return t.x=e.x*r,t.y=e.y*r,t.z=e.z*r,t},nt.computeAngle=function(e){return Math.abs(e.w-1)<H.CesiumMath.EPSILON6?0:2*Math.acos(e.w)};var mt=new nt;nt.lerp=function(e,t,n,r){return mt=nt.multiplyByScalar(t,n,mt),r=nt.multiplyByScalar(e,1-n,r),nt.add(mt,r,r)};var yt=new nt,vt=new nt,wt=new nt;nt.slerp=function(e,t,n,r){var a=nt.dot(e,t),i=t;if(a<0&&(a=-a,i=yt=nt.negate(t,yt)),1-a<H.CesiumMath.EPSILON6)return nt.lerp(e,i,n,r);var s=Math.acos(a);return vt=nt.multiplyByScalar(e,Math.sin((1-n)*s),vt),wt=nt.multiplyByScalar(i,Math.sin(n*s),wt),r=nt.add(vt,wt,r),nt.multiplyByScalar(r,1/Math.sin(s),r)},nt.log=function(e,t){var n=H.CesiumMath.acosClamped(e.w),r=0;return 0!==n&&(r=n/Math.sin(n)),D.Cartesian3.multiplyByScalar(e,r,t)},nt.exp=function(e,t){var n=D.Cartesian3.magnitude(e),r=0;return 0!==n&&(r=Math.sin(n)/n),t.x=e.x*r,t.y=e.y*r,t.z=e.z*r,t.w=Math.cos(n),t};var Ct=new D.Cartesian3,gt=new D.Cartesian3,xt=new nt,Et=new nt;nt.computeInnerQuadrangle=function(e,t,n,r){var a=nt.conjugate(t,xt);nt.multiply(a,n,Et);var i=nt.log(Et,Ct);nt.multiply(a,e,Et);var s=nt.log(Et,gt);return D.Cartesian3.add(i,s,i),D.Cartesian3.multiplyByScalar(i,.25,i),D.Cartesian3.negate(i,i),nt.exp(i,xt),nt.multiply(t,xt,r)},nt.squad=function(e,t,n,r,a,i){var s=nt.slerp(e,t,a,xt),o=nt.slerp(n,r,a,Et);return nt.slerp(s,o,2*a*(1-a),i)};for(var Ot=new nt,_t=1.9011074535173003,St=tt.supportsTypedArrays()?new Float32Array(8):[],bt=tt.supportsTypedArrays()?new Float32Array(8):[],Mt=tt.supportsTypedArrays()?new Float32Array(8):[],At=tt.supportsTypedArrays()?new Float32Array(8):[],Rt=0;Rt<7;++Rt){var Tt=Rt+1,zt=2*Tt+1;St[Rt]=1/(Tt*zt),bt[Rt]=Tt/zt}function qt(e,t,n){for(var r,a,i=0,s=e.length-1;i<=s;)if((a=n(e[r=~~((i+s)/2)],t))<0)i=1+r;else{if(!(0<a))return r;s=r-1}return~(s+1)}function It(e,t,n,r,a){this.xPoleWander=e,this.yPoleWander=t,this.xPoleOffset=n,this.yPoleOffset=r,this.ut1MinusUtc=a}function Pt(){function C(e,t,n,r){n=n||" ";var a=e.length>=t?"":Array(1+t-e.length>>>0).join(n);return r?e+a:a+e}function g(e,t,n,r,a,i){var s=r-e.length;return 0<s&&(e=n||!a?C(e,r,i,n):e.slice(0,t.length)+C("",s,"0",!0)+e.slice(t.length)),e}function x(e,t,n,r,a,i,s){var o=e>>>0;return e=(n=n&&o&&{2:"0b",8:"0",16:"0x"}[t]||"")+C(o.toString(t),i||0,"0",!1),g(e,n,r,a,s)}function E(e,t,n,r,a,i){return null!=r&&(e=e.slice(0,r)),g(e,"",t,n,a,i)}var O=arguments,_=0,e=O[_++];return e.replace(/%%|%(\d+\$)?([-+\'#0 ]*)(\*\d+\$|\*|\d+)?(\.(\*\d+\$|\*|\d+))?([scboxXuideEfFgG])/g,function(e,t,n,r,a,i,s){var o,u,l,c,f;if("%%"==e)return"%";for(var d=!1,h="",p=!1,m=!1,y=" ",v=n.length,w=0;n&&w<v;w++)switch(n.charAt(w)){case" ":h=" ";break;case"+":h="+";break;case"-":d=!0;break;case"'":y=n.charAt(w+1);break;case"0":p=!0;break;case"#":m=!0}if((r=r?"*"==r?+O[_++]:"*"==r.charAt(0)?+O[r.slice(1,-1)]:+r:0)<0&&(r=-r,d=!0),!isFinite(r))throw new Error("sprintf: (minimum-)width must be finite");switch(i=i?"*"==i?+O[_++]:"*"==i.charAt(0)?+O[i.slice(1,-1)]:+i:-1<"fFeE".indexOf(s)?6:"d"==s?0:void 0,f=t?O[t.slice(0,-1)]:O[_++],s){case"s":return E(String(f),d,r,i,p,y);case"c":return E(String.fromCharCode(+f),d,r,i,p);case"b":return x(f,2,m,d,r,i,p);case"o":return x(f,8,m,d,r,i,p);case"x":return x(f,16,m,d,r,i,p);case"X":return x(f,16,m,d,r,i,p).toUpperCase();case"u":return x(f,10,m,d,r,i,p);case"i":case"d":return o=+f||0,f=(u=(o=Math.round(o-o%1))<0?"-":h)+C(String(Math.abs(o)),i,"0",!1),g(f,u,d,r,p);case"e":case"E":case"f":case"F":case"g":case"G":return u=(o=+f)<0?"-":h,l=["toExponential","toFixed","toPrecision"]["efg".indexOf(s.toLowerCase())],c=["toString","toUpperCase"]["eEfFgG".indexOf(s)%2],f=u+Math.abs(o)[l](i),g(f,u,d,r,p)[c]();default:return e}})}function Dt(e,t,n,r,a,i,s,o){this.year=e,this.month=t,this.day=n,this.hour=r,this.minute=a,this.second=i,this.millisecond=s,this.isLeapSecond=o}function Nt(e){return e%4==0&&e%100!=0||e%400==0}function Ut(e,t){this.julianDate=e,this.offset=t}St[7]=_t/136,bt[7]=8*_t/17,nt.fastSlerp=function(e,t,n,r){var a,i=nt.dot(e,t);0<=i?a=1:(a=-1,i=-i);for(var s=i-1,o=1-n,u=n*n,l=o*o,c=7;0<=c;--c)Mt[c]=(St[c]*u-bt[c])*s,At[c]=(St[c]*l-bt[c])*s;var f=a*n*(1+Mt[0]*(1+Mt[1]*(1+Mt[2]*(1+Mt[3]*(1+Mt[4]*(1+Mt[5]*(1+Mt[6]*(1+Mt[7])))))))),d=o*(1+At[0]*(1+At[1]*(1+At[2]*(1+At[3]*(1+At[4]*(1+At[5]*(1+At[6]*(1+At[7])))))))),h=nt.multiplyByScalar(e,d,Ot);return nt.multiplyByScalar(t,f,r),nt.add(h,r,r)},nt.fastSquad=function(e,t,n,r,a,i){var s=nt.fastSlerp(e,t,a,xt),o=nt.fastSlerp(n,r,a,Et);return nt.fastSlerp(s,o,2*a*(1-a),i)},nt.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&e.x===t.x&&e.y===t.y&&e.z===t.z&&e.w===t.w},nt.equalsEpsilon=function(e,t,n){return e===t||I.defined(e)&&I.defined(t)&&Math.abs(e.x-t.x)<=n&&Math.abs(e.y-t.y)<=n&&Math.abs(e.z-t.z)<=n&&Math.abs(e.w-t.w)<=n},nt.ZERO=t.freezeObject(new nt(0,0,0,0)),nt.IDENTITY=t.freezeObject(new nt(0,0,0,1)),nt.prototype.clone=function(e){return nt.clone(this,e)},nt.prototype.equals=function(e){return nt.equals(this,e)},nt.prototype.equalsEpsilon=function(e,t){return nt.equalsEpsilon(this,e,t)},nt.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"};var Ft=t.freezeObject({SECONDS_PER_MILLISECOND:.001,SECONDS_PER_MINUTE:60,MINUTES_PER_HOUR:60,HOURS_PER_DAY:24,SECONDS_PER_HOUR:3600,MINUTES_PER_DAY:1440,SECONDS_PER_DAY:86400,DAYS_PER_JULIAN_CENTURY:36525,PICOSECOND:1e-9,MODIFIED_JULIAN_DATE_DIFFERENCE:2400000.5}),Vt=t.freezeObject({UTC:0,TAI:1}),Lt=new Dt,Bt=[31,28,31,30,31,30,31,31,30,31,30,31];function Wt(e,t){return rn.compare(e.julianDate,t.julianDate)}var jt=new Ut;function kt(e){jt.julianDate=e;var t=rn.leapSeconds,n=qt(t,jt,Wt);n<0&&(n=~n),n>=t.length&&(n=t.length-1);var r=t[n].offset;0<n&&r<rn.secondsDifference(t[n].julianDate,e)&&(r=t[--n].offset);rn.addSeconds(e,r,e)}function Yt(e,t){jt.julianDate=e;var n=rn.leapSeconds,r=qt(n,jt,Wt);if(r<0&&(r=~r),0===r)return rn.addSeconds(e,-n[0].offset,t);if(r>=n.length)return rn.addSeconds(e,-n[r-1].offset,t);var a=rn.secondsDifference(n[r].julianDate,e);return 0===a?rn.addSeconds(e,-n[r].offset,t):a<=1?void 0:rn.addSeconds(e,-n[--r].offset,t)}function Zt(e,t,n){var r=t/Ft.SECONDS_PER_DAY|0;return e+=r,(t-=Ft.SECONDS_PER_DAY*r)<0&&(e--,t+=Ft.SECONDS_PER_DAY),n.dayNumber=e,n.secondsOfDay=t,n}function Ht(e,t,n,r,a,i,s){var o=(t-14)/12|0,u=e+4800+o,l=(1461*u/4|0)+(367*(t-2-12*o)/12|0)-(3*((u+100)/100|0)/4|0)+n-32075;(r-=12)<0&&(r+=24);var c=i+(r*Ft.SECONDS_PER_HOUR+a*Ft.SECONDS_PER_MINUTE+s*Ft.SECONDS_PER_MILLISECOND);return 43200<=c&&--l,[l,c]}var Jt=/^(\d{4})$/,Xt=/^(\d{4})-(\d{2})$/,Gt=/^(\d{4})-?(\d{3})$/,Qt=/^(\d{4})-?W(\d{2})-?(\d{1})?$/,Kt=/^(\d{4})-?(\d{2})-?(\d{2})$/,$t=/([Z+\-])?(\d{2})?:?(\d{2})?$/,en=/^(\d{2})(\.\d+)?/.source+$t.source,tn=/^(\d{2}):?(\d{2})(\.\d+)?/.source+$t.source,nn=/^(\d{2}):?(\d{2}):?(\d{2})(\.\d+)?/.source+$t.source;function rn(e,t,n){this.dayNumber=void 0,this.secondsOfDay=void 0,e=P.defaultValue(e,0),t=P.defaultValue(t,0),n=P.defaultValue(n,Vt.UTC);var r=0|e;Zt(r,t+=(e-r)*Ft.SECONDS_PER_DAY,this),n===Vt.UTC&&kt(this)}rn.fromGregorianDate=function(e,t){var n=Ht(e.year,e.month,e.day,e.hour,e.minute,e.second,e.millisecond);return I.defined(t)?(Zt(n[0],n[1],t),kt(t),t):new rn(n[0],n[1],Vt.UTC)},rn.fromDate=function(e,t){var n=Ht(e.getUTCFullYear(),e.getUTCMonth()+1,e.getUTCDate(),e.getUTCHours(),e.getUTCMinutes(),e.getUTCSeconds(),e.getUTCMilliseconds());return I.defined(t)?(Zt(n[0],n[1],t),kt(t),t):new rn(n[0],n[1],Vt.UTC)},rn.fromIso8601=function(e,t){var n,r,a,i,s=(e=e.replace(",",".")).split("T"),o=1,u=1,l=0,c=0,f=0,d=0,h=s[0],p=s[1];if(null!==(s=h.match(Kt)))n=+s[1],o=+s[2],u=+s[3];else if(null!==(s=h.match(Xt)))n=+s[1],o=+s[2];else if(null!==(s=h.match(Jt)))n=+s[1];else{var m;if(null!==(s=h.match(Gt)))n=+s[1],m=+s[2],a=Nt(n);else if(null!==(s=h.match(Qt)))n=+s[1],m=7*+s[2]+(+s[3]||0)-new Date(Date.UTC(n,0,4)).getUTCDay()-3;(r=new Date(Date.UTC(n,0,1))).setUTCDate(m),o=r.getUTCMonth()+1,u=r.getUTCDate()}if(a=Nt(n),I.defined(p)){null!==(s=p.match(nn))?(l=+s[1],c=+s[2],f=+s[3],d=1e3*(s[4]||0),i=5):null!==(s=p.match(tn))?(l=+s[1],c=+s[2],f=60*(s[3]||0),i=4):null!==(s=p.match(en))&&(l=+s[1],c=60*(s[2]||0),i=3);var y=s[i],v=+s[i+1],w=+(s[i+2]||0);switch(y){case"+":l-=v,c-=w;break;case"-":l+=v,c+=w;break;case"Z":break;default:c+=new Date(Date.UTC(n,o-1,u,l,c)).getTimezoneOffset()}}var C=60===f;for(C&&f--;60<=c;)c-=60,l++;for(;24<=l;)l-=24,u++;for(r=a&&2===o?29:Bt[o-1];r<u;)u-=r,12<++o&&(o-=12,n++),r=a&&2===o?29:Bt[o-1];for(;c<0;)c+=60,l--;for(;l<0;)l+=24,u--;for(;u<1;)--o<1&&(o+=12,n--),u+=r=a&&2===o?29:Bt[o-1];var g=Ht(n,o,u,l,c,f,d);return I.defined(t)?(Zt(g[0],g[1],t),kt(t)):t=new rn(g[0],g[1],Vt.UTC),C&&rn.addSeconds(t,1,t),t},rn.now=function(e){return rn.fromDate(new Date,e)};var an=new rn(0,0,Vt.TAI);function sn(e){if(e instanceof sn)this.scheme=e.scheme,this.authority=e.authority,this.path=e.path,this.query=e.query,this.fragment=e.fragment;else if(e){var t=on.exec(e);this.scheme=t[1],this.authority=t[2],this.path=t[3],this.query=t[4],this.fragment=t[5]}}rn.toGregorianDate=function(e,t){var n=!1,r=Yt(e,an);I.defined(r)||(rn.addSeconds(e,-1,an),r=Yt(an,an),n=!0);var a=r.dayNumber,i=r.secondsOfDay;43200<=i&&(a+=1);var s=a+68569|0,o=4*s/146097|0,u=4e3*((s=s-((146097*o+3)/4|0)|0)+1)/1461001|0,l=80*(s=s-(1461*u/4|0)+31|0)/2447|0,c=s-(2447*l/80|0)|0,f=2+l-12*(s=l/11|0)|0,d=100*(o-49)+u+s|0,h=i/Ft.SECONDS_PER_HOUR|0,p=i-h*Ft.SECONDS_PER_HOUR,m=p/Ft.SECONDS_PER_MINUTE|0,y=0|(p-=m*Ft.SECONDS_PER_MINUTE),v=(p-y)/Ft.SECONDS_PER_MILLISECOND;return 23<(h+=12)&&(h-=24),n&&(y+=1),I.defined(t)?(t.year=d,t.month=f,t.day=c,t.hour=h,t.minute=m,t.second=y,t.millisecond=v,t.isLeapSecond=n,t):new Dt(d,f,c,h,m,y,v,n)},rn.toDate=function(e){var t=rn.toGregorianDate(e,Lt),n=t.second;return t.isLeapSecond&&--n,new Date(Date.UTC(t.year,t.month-1,t.day,t.hour,t.minute,n,t.millisecond))},rn.toIso8601=function(e,t){var n=rn.toGregorianDate(e,Lt),r=n.year,a=n.month,i=n.day,s=n.hour,o=n.minute,u=n.second,l=n.millisecond;return 1e4===r&&1===a&&1===i&&0===s&&0===o&&0===u&&0===l&&(r=9999,a=12,i=31,s=24),I.defined(t)||0===l?I.defined(t)&&0!==t?Pt("%04d-%02d-%02dT%02d:%02d:%02d.%sZ",r,a,i,s,o,u,(.01*l).toFixed(t).replace(".","").slice(0,t)):Pt("%04d-%02d-%02dT%02d:%02d:%02dZ",r,a,i,s,o,u):Pt("%04d-%02d-%02dT%02d:%02d:%02d.%sZ",r,a,i,s,o,u,(.01*l).toString().replace(".",""))},rn.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t.dayNumber=e.dayNumber,t.secondsOfDay=e.secondsOfDay,t):new rn(e.dayNumber,e.secondsOfDay,Vt.TAI)},rn.compare=function(e,t){var n=e.dayNumber-t.dayNumber;return 0!=n?n:e.secondsOfDay-t.secondsOfDay},rn.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&e.dayNumber===t.dayNumber&&e.secondsOfDay===t.secondsOfDay},rn.equalsEpsilon=function(e,t,n){return e===t||I.defined(e)&&I.defined(t)&&Math.abs(rn.secondsDifference(e,t))<=n},rn.totalDays=function(e){return e.dayNumber+e.secondsOfDay/Ft.SECONDS_PER_DAY},rn.secondsDifference=function(e,t){return(e.dayNumber-t.dayNumber)*Ft.SECONDS_PER_DAY+(e.secondsOfDay-t.secondsOfDay)},rn.daysDifference=function(e,t){return e.dayNumber-t.dayNumber+(e.secondsOfDay-t.secondsOfDay)/Ft.SECONDS_PER_DAY},rn.computeTaiMinusUtc=function(e){jt.julianDate=e;var t=rn.leapSeconds,n=qt(t,jt,Wt);return n<0&&(n=~n,--n<0&&(n=0)),t[n].offset},rn.addSeconds=function(e,t,n){return Zt(e.dayNumber,e.secondsOfDay+t,n)},rn.addMinutes=function(e,t,n){var r=e.secondsOfDay+t*Ft.SECONDS_PER_MINUTE;return Zt(e.dayNumber,r,n)},rn.addHours=function(e,t,n){var r=e.secondsOfDay+t*Ft.SECONDS_PER_HOUR;return Zt(e.dayNumber,r,n)},rn.addDays=function(e,t,n){return Zt(e.dayNumber+t,e.secondsOfDay,n)},rn.lessThan=function(e,t){return rn.compare(e,t)<0},rn.lessThanOrEquals=function(e,t){return rn.compare(e,t)<=0},rn.greaterThan=function(e,t){return 0<rn.compare(e,t)},rn.greaterThanOrEquals=function(e,t){return 0<=rn.compare(e,t)},rn.prototype.clone=function(e){return rn.clone(this,e)},rn.prototype.equals=function(e){return rn.equals(this,e)},rn.prototype.equalsEpsilon=function(e,t){return rn.equalsEpsilon(this,e,t)},rn.prototype.toString=function(){return rn.toIso8601(this)},rn.leapSeconds=[new Ut(new rn(2441317,43210,Vt.TAI),10),new Ut(new rn(2441499,43211,Vt.TAI),11),new Ut(new rn(2441683,43212,Vt.TAI),12),new Ut(new rn(2442048,43213,Vt.TAI),13),new Ut(new rn(2442413,43214,Vt.TAI),14),new Ut(new rn(2442778,43215,Vt.TAI),15),new Ut(new rn(2443144,43216,Vt.TAI),16),new Ut(new rn(2443509,43217,Vt.TAI),17),new Ut(new rn(2443874,43218,Vt.TAI),18),new Ut(new rn(2444239,43219,Vt.TAI),19),new Ut(new rn(2444786,43220,Vt.TAI),20),new Ut(new rn(2445151,43221,Vt.TAI),21),new Ut(new rn(2445516,43222,Vt.TAI),22),new Ut(new rn(2446247,43223,Vt.TAI),23),new Ut(new rn(2447161,43224,Vt.TAI),24),new Ut(new rn(2447892,43225,Vt.TAI),25),new Ut(new rn(2448257,43226,Vt.TAI),26),new Ut(new rn(2448804,43227,Vt.TAI),27),new Ut(new rn(2449169,43228,Vt.TAI),28),new Ut(new rn(2449534,43229,Vt.TAI),29),new Ut(new rn(2450083,43230,Vt.TAI),30),new Ut(new rn(2450630,43231,Vt.TAI),31),new Ut(new rn(2451179,43232,Vt.TAI),32),new Ut(new rn(2453736,43233,Vt.TAI),33),new Ut(new rn(2454832,43234,Vt.TAI),34),new Ut(new rn(2456109,43235,Vt.TAI),35),new Ut(new rn(2457204,43236,Vt.TAI),36),new Ut(new rn(2457754,43237,Vt.TAI),37)],sn.prototype.scheme=null,sn.prototype.authority=null,sn.prototype.path="",sn.prototype.query=null,sn.prototype.fragment=null;var on=new RegExp("^(?:([^:/?#]+):)?(?://([^/?#]*))?([^?#]*)(?:\\?([^#]*))?(?:#(.*))?$");sn.prototype.getScheme=function(){return this.scheme},sn.prototype.getAuthority=function(){return this.authority},sn.prototype.getPath=function(){return this.path},sn.prototype.getQuery=function(){return this.query},sn.prototype.getFragment=function(){return this.fragment},sn.prototype.isAbsolute=function(){return!!this.scheme&&!this.fragment},sn.prototype.isSameDocumentAs=function(e){return e.scheme==this.scheme&&e.authority==this.authority&&e.path==this.path&&e.query==this.query},sn.prototype.equals=function(e){return this.isSameDocumentAs(e)&&e.fragment==this.fragment},sn.prototype.normalize=function(){this.removeDotSegments(),this.scheme&&(this.scheme=this.scheme.toLowerCase()),this.authority&&(this.authority=this.authority.replace(cn,dn).replace(un,fn)),this.path&&(this.path=this.path.replace(un,fn)),this.query&&(this.query=this.query.replace(un,fn)),this.fragment&&(this.fragment=this.fragment.replace(un,fn))};var un=/%[0-9a-z]{2}/gi,ln=/[a-zA-Z0-9\-\._~]/,cn=/(.*@)?([^@:]*)(:.*)?/;function fn(e){var t=unescape(e);return ln.test(t)?t:e.toUpperCase()}function dn(e,t,n,r){return(t||"")+n.toLowerCase()+(r||"")}function hn(e,t){if(null===e||"object"!=typeof e)return e;t=P.defaultValue(t,!1);var n=new e.constructor;for(var r in e)if(e.hasOwnProperty(r)){var a=e[r];t&&(a=hn(a,t)),n[r]=a}return n}function pn(e,t,n){n=P.defaultValue(n,!1);var r,a,i,s={},o=I.defined(e),u=I.defined(t);if(o)for(r in e)e.hasOwnProperty(r)&&(a=e[r],u&&n&&"object"==typeof a&&t.hasOwnProperty(r)?(i=t[r],s[r]="object"==typeof i?pn(a,i,n):a):s[r]=a);if(u)for(r in t)t.hasOwnProperty(r)&&!s.hasOwnProperty(r)&&(i=t[r],s[r]=i);return s}function mn(e,t){var n;return"undefined"!=typeof document&&(n=document),mn._implementation(e,t,n)}sn.prototype.resolve=function(e){var t=new sn;return this.scheme?(t.scheme=this.scheme,t.authority=this.authority,t.path=this.path,t.query=this.query):(t.scheme=e.scheme,this.authority?(t.authority=this.authority,t.path=this.path,t.query=this.query):(t.authority=e.authority,""==this.path?(t.path=e.path,t.query=this.query||e.query):("/"==this.path.charAt(0)?t.path=this.path:e.authority&&""==e.path?t.path="/"+this.path:t.path=e.path.substring(0,e.path.lastIndexOf("/")+1)+this.path,t.removeDotSegments(),t.query=this.query))),t.fragment=this.fragment,t},sn.prototype.removeDotSegments=function(){var e,t=this.path.split("/"),n=[],r=""==t[0];r&&t.shift();for(""==t[0]&&t.shift();t.length;)".."==(e=t.shift())?n.pop():"."!=e&&n.push(e);"."!=e&&".."!=e||n.push(""),r&&n.unshift(""),this.path=n.join("/")},sn.prototype.toString=function(){var e="";return this.scheme&&(e+=this.scheme+":"),this.authority&&(e+="//"+this.authority),e+=this.path,this.query&&(e+="?"+this.query),this.fragment&&(e+="#"+this.fragment),e},mn._implementation=function(e,t,n){if(!I.defined(t)){if(void 0===n)return e;t=P.defaultValue(n.baseURI,n.location.href)}var r=new sn(t);return new sn(e).resolve(r).toString()};var yn,vn=/^blob:/i;function wn(e){return vn.test(e)}var Cn=/^data:/i;function gn(e){return Cn.test(e)}var xn=Array.isArray;I.defined(xn)||(xn=function(e){return"[object Array]"===Object.prototype.toString.call(e)});var En=xn;var On=t.freezeObject({UNISSUED:0,ISSUED:1,ACTIVE:2,RECEIVED:3,CANCELLED:4,FAILED:5}),_n=t.freezeObject({TERRAIN:0,IMAGERY:1,TILES3D:2,OTHER:3});function Sn(e){e=P.defaultValue(e,P.defaultValue.EMPTY_OBJECT);var t=P.defaultValue(e.throttleByServer,!1),n=P.defaultValue(e.throttle,!1);this.url=e.url,this.requestFunction=e.requestFunction,this.cancelFunction=e.cancelFunction,this.priorityFunction=e.priorityFunction,this.priority=P.defaultValue(e.priority,0),this.throttle=n,this.throttleByServer=t,this.type=P.defaultValue(e.type,_n.OTHER),this.serverKey=void 0,this.state=On.UNISSUED,this.deferred=void 0,this.cancelled=!1}function bn(e,t,n){this.statusCode=e,this.response=t,this.responseHeaders=n,"string"==typeof this.responseHeaders&&(this.responseHeaders=function(e){var t={};if(!e)return t;for(var n=e.split("\r\n"),r=0;r<n.length;++r){var a=n[r],i=a.indexOf(": ");if(0<i){var s=a.substring(0,i),o=a.substring(i+2);t[s]=o}}return t}(this.responseHeaders))}function Mn(){this._listeners=[],this._scopes=[],this._toRemove=[],this._insideRaiseEvent=!1}function An(e,t){return t-e}function Rn(e){this._comparator=e.comparator,this._array=[],this._length=0,this._maximumLength=void 0}function Tn(e,t,n){var r=e[t];e[t]=e[n],e[n]=r}Sn.prototype.cancel=function(){this.cancelled=!0},Sn.prototype.clone=function(e){return I.defined(e)?(e.url=this.url,e.requestFunction=this.requestFunction,e.cancelFunction=this.cancelFunction,e.priorityFunction=this.priorityFunction,e.priority=this.priority,e.throttle=this.throttle,e.throttleByServer=this.throttleByServer,e.type=this.type,e.serverKey=this.serverKey,e.state=this.RequestState.UNISSUED,e.deferred=void 0,e.cancelled=!1,e):new Sn(this)},bn.prototype.toString=function(){var e="Request has failed.";return I.defined(this.statusCode)&&(e+=" Status Code: "+this.statusCode),e},r.defineProperties(Mn.prototype,{numberOfListeners:{get:function(){return this._listeners.length-this._toRemove.length}}}),Mn.prototype.addEventListener=function(e,t){this._listeners.push(e),this._scopes.push(t);var n=this;return function(){n.removeEventListener(e,t)}},Mn.prototype.removeEventListener=function(e,t){for(var n=this._listeners,r=this._scopes,a=-1,i=0;i<n.length;i++)if(n[i]===e&&r[i]===t){a=i;break}return-1!==a&&(this._insideRaiseEvent?(this._toRemove.push(a),n[a]=void 0,r[a]=void 0):(n.splice(a,1),r.splice(a,1)),!0)},Mn.prototype.raiseEvent=function(){var e;this._insideRaiseEvent=!0;var t=this._listeners,n=this._scopes,r=t.length;for(e=0;e<r;e++){var a=t[e];I.defined(a)&&t[e].apply(n[e],arguments)}var i=this._toRemove;if(0<(r=i.length)){for(i.sort(An),e=0;e<r;e++){var s=i[e];t.splice(s,1),n.splice(s,1)}i.length=0}this._insideRaiseEvent=!1},r.defineProperties(Rn.prototype,{length:{get:function(){return this._length}},internalArray:{get:function(){return this._array}},maximumLength:{get:function(){return this._maximumLength},set:function(e){this._maximumLength=e,this._length>e&&0<e&&(this._length=e,this._array.length=e)}},comparator:{get:function(){return this._comparator}}}),Rn.prototype.reserve=function(e){e=P.defaultValue(e,this._length),this._array.length=e},Rn.prototype.heapify=function(e){e=P.defaultValue(e,0);for(var t=this._length,n=this._comparator,r=this._array,a=-1,i=!0;i;){var s=2*(e+1),o=s-1;a=o<t&&n(r[o],r[e])<0?o:e,s<t&&n(r[s],r[a])<0&&(a=s),a!==e?(Tn(r,a,e),e=a):i=!1}},Rn.prototype.resort=function(){for(var e=this._length,t=Math.ceil(e/2);0<=t;--t)this.heapify(t)},Rn.prototype.insert=function(e){var t,n=this._array,r=this._comparator,a=this._maximumLength,i=this._length++;for(i<n.length?n[i]=e:n.push(e);0!==i;){var s=Math.floor((i-1)/2);if(!(r(n[i],n[s])<0))break;Tn(n,i,s),i=s}return I.defined(a)&&this._length>a&&(t=n[a],this._length=a),t},Rn.prototype.pop=function(e){if(e=P.defaultValue(e,0),0!==this._length){var t=this._array,n=t[e];return Tn(t,e,--this._length),this.heapify(e),n}};var zn={numberOfAttemptedRequests:0,numberOfActiveRequests:0,numberOfCancelledRequests:0,numberOfCancelledActiveRequests:0,numberOfFailedRequests:0,numberOfActiveRequestsEver:0,lastNumberOfActiveRequests:0},qn=20,In=new Rn({comparator:function(e,t){return e.priority-t.priority}});In.maximumLength=qn,In.reserve(qn);var Pn=[],Dn={},Nn="undefined"!=typeof document?new sn(document.location.href):new sn,Un=new Mn;function Fn(){}function Vn(e){I.defined(e.priorityFunction)&&(e.priority=e.priorityFunction())}function Ln(e){var t=P.defaultValue(Fn.requestsByServer[e],Fn.maximumRequestsPerServer);return Dn[e]<t}function Bn(e){return e.state===On.UNISSUED&&(e.state=On.ISSUED,e.deferred=d.when.defer()),e.deferred.promise}function Wn(e){var t,n,r=Bn(e);return e.state=On.ACTIVE,Pn.push(e),++zn.numberOfActiveRequests,++zn.numberOfActiveRequestsEver,++Dn[e.serverKey],e.requestFunction().then((n=e,function(e){n.state!==On.CANCELLED&&(--zn.numberOfActiveRequests,--Dn[n.serverKey],Un.raiseEvent(),n.state=On.RECEIVED,n.deferred.resolve(e))})).otherwise((t=e,function(e){t.state!==On.CANCELLED&&(++zn.numberOfFailedRequests,--zn.numberOfActiveRequests,--Dn[t.serverKey],Un.raiseEvent(e),t.state=On.FAILED,t.deferred.reject(e))})),r}function jn(e){var t=e.state===On.ACTIVE;e.state=On.CANCELLED,++zn.numberOfCancelledRequests,e.deferred.reject(),t&&(--zn.numberOfActiveRequests,--Dn[e.serverKey],++zn.numberOfCancelledActiveRequests),I.defined(e.cancelFunction)&&e.cancelFunction()}Fn.maximumRequests=50,Fn.maximumRequestsPerServer=6,Fn.requestsByServer={"api.cesium.com:443":18,"assets.cesium.com:443":18},Fn.throttleRequests=!0,Fn.debugShowStatistics=!1,Fn.requestCompletedEvent=Un,r.defineProperties(Fn,{statistics:{get:function(){return zn}},priorityHeapLength:{get:function(){return qn},set:function(e){if(e<qn)for(;In.length>e;){jn(In.pop())}qn=e,In.maximumLength=e,In.reserve(e)}}}),Fn.update=function(){var e,t,n=0,r=Pn.length;for(e=0;e<r;++e)(t=Pn[e]).cancelled&&jn(t),t.state===On.ACTIVE?0<n&&(Pn[e-n]=t):++n;Pn.length-=n;var a=In.internalArray,i=In.length;for(e=0;e<i;++e)Vn(a[e]);In.resort();for(var s=Math.max(Fn.maximumRequests-Pn.length,0),o=0;o<s&&0<In.length;)(t=In.pop()).cancelled?jn(t):!t.throttleByServer||Ln(t.serverKey)?(Wn(t),++o):jn(t);!function(){if(!Fn.debugShowStatistics)return;0===zn.numberOfActiveRequests&&0<zn.lastNumberOfActiveRequests&&(0<zn.numberOfAttemptedRequests&&(console.log("Number of attempted requests: "+zn.numberOfAttemptedRequests),zn.numberOfAttemptedRequests=0),0<zn.numberOfCancelledRequests&&(console.log("Number of cancelled requests: "+zn.numberOfCancelledRequests),zn.numberOfCancelledRequests=0),0<zn.numberOfCancelledActiveRequests&&(console.log("Number of cancelled active requests: "+zn.numberOfCancelledActiveRequests),zn.numberOfCancelledActiveRequests=0),0<zn.numberOfFailedRequests&&(console.log("Number of failed requests: "+zn.numberOfFailedRequests),zn.numberOfFailedRequests=0));zn.lastNumberOfActiveRequests=zn.numberOfActiveRequests}()},Fn.getServerKey=function(e){var t=new sn(e).resolve(Nn);t.normalize();var n=t.authority;/:/.test(n)||(n=n+":"+("https"===t.scheme?"443":"80"));var r=Dn[n];return I.defined(r)||(Dn[n]=0),n},Fn.request=function(e){if(gn(e.url)||wn(e.url))return Un.raiseEvent(),e.state=On.RECEIVED,e.requestFunction();if(++zn.numberOfAttemptedRequests,I.defined(e.serverKey)||(e.serverKey=Fn.getServerKey(e.url)),!e.throttleByServer||Ln(e.serverKey)){if(!Fn.throttleRequests||!e.throttle)return Wn(e);if(!(Pn.length>=Fn.maximumRequests)){Vn(e);var t=In.insert(e);if(I.defined(t)){if(t===e)return;jn(t)}return Bn(e)}}},Fn.clearForSpecs=function(){for(;0<In.length;){jn(In.pop())}for(var e=Pn.length,t=0;t<e;++t)jn(Pn[t]);Pn.length=0,Dn={},zn.numberOfAttemptedRequests=0,zn.numberOfActiveRequests=0,zn.numberOfCancelledRequests=0,zn.numberOfCancelledActiveRequests=0,zn.numberOfFailedRequests=0,zn.numberOfActiveRequestsEver=0,zn.lastNumberOfActiveRequests=0},Fn.numberOfActiveRequestsByServer=function(e){return Dn[e]},Fn.requestHeap=In;var kn={},Yn={};kn.add=function(e,t){var n=e.toLowerCase()+":"+t;I.defined(Yn[n])||(Yn[n]=!0)},kn.remove=function(e,t){var n=e.toLowerCase()+":"+t;I.defined(Yn[n])&&delete Yn[n]},kn.contains=function(e){var t=function(e){var t=new sn(e);t.normalize();var n=t.getAuthority();if(I.defined(n)){if(-1!==n.indexOf("@"))n=n.split("@")[1];if(-1===n.indexOf(":")){var r=t.getScheme();if(I.defined(r)||(r=(r=window.location.protocol).substring(0,r.length-1)),"http"===r)n+=":80";else{if("https"!==r)return;n+=":443"}}return n}}(e);return!(!I.defined(t)||!I.defined(Yn[t]))},kn.clear=function(){Yn={}};var Zn,Hn=function(){try{var e=new XMLHttpRequest;return e.open("GET","#",!0),(e.responseType="blob")===e.responseType}catch(e){return!1}}();function Jn(e,t,n,r){var a,i=e.query;if(!I.defined(i)||0===i.length)return{};if(-1===i.indexOf("=")){var s={};s[i]=void 0,a=s}else a=function(e){var t={};if(""===e)return t;for(var n=e.replace(/\+/g,"%20").split(/[&;]/),r=0,a=n.length;r<a;++r){var i=n[r].split("="),s=decodeURIComponent(i[0]),o=i[1];o=I.defined(o)?decodeURIComponent(o):"";var u=t[s];"string"==typeof u?t[s]=[u,o]:En(u)?u.push(o):t[s]=o}return t}(i);t._queryParameters=n?Kn(a,t._queryParameters,r):a,e.query=void 0}function Xn(e,t){var n=t._queryParameters,r=Object.keys(n);1!==r.length||I.defined(n[r[0]])?e.query=function(e){var t="";for(var n in e)if(e.hasOwnProperty(n)){var r=e[n],a=encodeURIComponent(n)+"=";if(En(r))for(var i=0,s=r.length;i<s;++i)t+=a+encodeURIComponent(r[i])+"&";else t+=a+encodeURIComponent(r)+"&"}return t=t.slice(0,-1)}(n):e.query=r[0]}function Gn(e,t){return I.defined(e)?I.defined(e.clone)?e.clone():hn(e):t}function Qn(e){if(e.state===On.ISSUED||e.state===On.ACTIVE)throw new J.RuntimeError("The Resource is already being fetched.");e.state=On.UNISSUED,e.deferred=void 0}function Kn(e,t,n){if(!n)return pn(e,t);var r=hn(e,!0);for(var a in t)if(t.hasOwnProperty(a)){var i=r[a],s=t[a];I.defined(i)?(Array.isArray(i)||(i=r[a]=[i]),r[a]=i.concat(s)):r[a]=Array.isArray(s)?s.slice():s}return r}function $n(e){"string"==typeof(e=P.defaultValue(e,P.defaultValue.EMPTY_OBJECT))&&(e={url:e}),this._url=void 0,this._templateValues=Gn(e.templateValues,{}),this._queryParameters=Gn(e.queryParameters,{}),this.headers=Gn(e.headers,{}),this.request=P.defaultValue(e.request,new Sn),this.proxy=e.proxy,this.retryCallback=e.retryCallback,this.retryAttempts=P.defaultValue(e.retryAttempts,0),this._retryCount=0;var t=new sn(e.url);Jn(t,this,!0,!0),t.fragment=void 0,this._url=t.toString()}function er(e){var r=e.resource,a=e.flipY,i=e.preferImageBitmap,n=r.request;n.url=r.url,n.requestFunction=function(){var e=r.url,t=!1;r.isDataUri||r.isBlobUri||(t=r.isCrossOriginUrl);var n=d.when.defer();return $n._Implementations.createImage(e,t,n,a,i),n.promise};var t=Fn.request(n);if(I.defined(t))return t.otherwise(function(t){return n.state!==On.FAILED?d.when.reject(t):r.retryOnError(t).then(function(e){return e?(n.state=On.UNISSUED,n.deferred=void 0,er({resource:r,flipY:a,preferImageBitmap:i})):d.when.reject(t)})})}$n.createIfNeeded=function(e){return e instanceof $n?e.getDerivedResource({request:e.request}):"string"!=typeof e?e:new $n({url:e})},$n.supportsImageBitmapOptions=function(){if(I.defined(Zn))return Zn;if("function"!=typeof createImageBitmap)return Zn=d.when.resolve(!1);return Zn=$n.fetchBlob({url:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQImWP4////fwAJ+wP9CNHoHgAAAABJRU5ErkJggg=="}).then(function(e){return createImageBitmap(e,{imageOrientation:"flipY",premultiplyAlpha:"none"})}).then(function(e){return!0}).otherwise(function(){return!1})},r.defineProperties($n,{isBlobSupported:{get:function(){return Hn}}}),r.defineProperties($n.prototype,{queryParameters:{get:function(){return this._queryParameters}},templateValues:{get:function(){return this._templateValues}},url:{get:function(){return this.getUrlComponent(!0,!0)},set:function(e){var t=new sn(e);Jn(t,this,!1),t.fragment=void 0,this._url=t.toString()}},extension:{get:function(){return function(e){var t=new sn(e);t.normalize();var n=t.path,r=n.lastIndexOf("/");return-1!==r&&(n=n.substr(r+1)),n=-1===(r=n.lastIndexOf("."))?"":n.substr(r+1)}(this._url)}},isDataUri:{get:function(){return gn(this._url)}},isBlobUri:{get:function(){return wn(this._url)}},isCrossOriginUrl:{get:function(){return function(e){I.defined(yn)||(yn=document.createElement("a")),yn.href=window.location.href;var t=yn.host,n=yn.protocol;return yn.href=e,yn.href=yn.href,n!==yn.protocol||t!==yn.host}(this._url)}},hasHeaders:{get:function(){return 0<Object.keys(this.headers).length}}}),$n.prototype.getUrlComponent=function(e,t){if(this.isDataUri)return this._url;var n=new sn(this._url);e&&Xn(n,this);var r=n.toString().replace(/%7B/g,"{").replace(/%7D/g,"}"),a=this._templateValues;return r=r.replace(/{(.*?)}/g,function(e,t){var n=a[t];return I.defined(n)?encodeURIComponent(n):e}),t&&I.defined(this.proxy)&&(r=this.proxy.getURL(r)),r},$n.prototype.setQueryParameters=function(e,t){this._queryParameters=t?Kn(this._queryParameters,e,!1):Kn(e,this._queryParameters,!1)},$n.prototype.appendQueryParameters=function(e){this._queryParameters=Kn(e,this._queryParameters,!0)},$n.prototype.setTemplateValues=function(e,t){this._templateValues=t?pn(this._templateValues,e):pn(e,this._templateValues)},$n.prototype.getDerivedResource=function(e){var t=this.clone();if(t._retryCount=0,I.defined(e.url)){var n=new sn(e.url);Jn(n,t,!0,P.defaultValue(e.preserveQueryParameters,!1)),n.fragment=void 0,t._url=n.resolve(new sn(mn(this._url))).toString()}return I.defined(e.queryParameters)&&(t._queryParameters=pn(e.queryParameters,t._queryParameters)),I.defined(e.templateValues)&&(t._templateValues=pn(e.templateValues,t.templateValues)),I.defined(e.headers)&&(t.headers=pn(e.headers,t.headers)),I.defined(e.proxy)&&(t.proxy=e.proxy),I.defined(e.request)&&(t.request=e.request),I.defined(e.retryCallback)&&(t.retryCallback=e.retryCallback),I.defined(e.retryAttempts)&&(t.retryAttempts=e.retryAttempts),t},$n.prototype.retryOnError=function(e){var t=this.retryCallback;if("function"!=typeof t||this._retryCount>=this.retryAttempts)return d.when(!1);var n=this;return d.when(t(this,e)).then(function(e){return++n._retryCount,e})},$n.prototype.clone=function(e){return I.defined(e)||(e=new $n({url:this._url})),e._url=this._url,e._queryParameters=hn(this._queryParameters),e._templateValues=hn(this._templateValues),e.headers=hn(this.headers),e.proxy=this.proxy,e.retryCallback=this.retryCallback,e.retryAttempts=this.retryAttempts,e._retryCount=0,e.request=this.request.clone(),e},$n.prototype.getBaseUri=function(e){return t=this.getUrlComponent(e),n=e,r="",-1!==(a=t.lastIndexOf("/"))&&(r=t.substring(0,a+1)),n&&(t=new sn(t),I.defined(t.query)&&(r+="?"+t.query),I.defined(t.fragment)&&(r+="#"+t.fragment)),r;var t,n,r,a},$n.prototype.appendForwardSlash=function(){var e;this._url=(0!==(e=this._url).length&&"/"===e[e.length-1]||(e+="/"),e)},$n.prototype.fetchArrayBuffer=function(){return this.fetch({responseType:"arraybuffer"})},$n.fetchArrayBuffer=function(e){return new $n(e).fetchArrayBuffer()},$n.prototype.fetchBlob=function(){return this.fetch({responseType:"blob"})},$n.fetchBlob=function(e){return new $n(e).fetchBlob()},$n.prototype.fetchImage=function(e){e=P.defaultValue(e,P.defaultValue.EMPTY_OBJECT);var t=P.defaultValue(e.preferImageBitmap,!1),n=P.defaultValue(e.preferBlob,!1),r=P.defaultValue(e.flipY,!1);if(Qn(this.request),!Hn||this.isDataUri||this.isBlobUri||!this.hasHeaders&&!n)return er({resource:this,flipY:r,preferImageBitmap:t});var a,i,s,o=this.fetchBlob();return I.defined(o)?$n.supportsImageBitmapOptions().then(function(e){return a=e&&t,o}).then(function(e){if(I.defined(e)){if(s=e,a)return $n.createImageBitmapFromBlob(e,{flipY:r,premultiplyAlpha:!1});var t=window.URL.createObjectURL(e);return er({resource:i=new $n({url:t}),flipY:r,preferImageBitmap:!1})}}).then(function(e){if(I.defined(e))return e.blob=s,a||window.URL.revokeObjectURL(i.url),e}).otherwise(function(e){return I.defined(i)&&window.URL.revokeObjectURL(i.url),e.blob=s,d.when.reject(e)}):void 0},$n.fetchImage=function(e){return new $n(e).fetchImage({flipY:e.flipY,preferBlob:e.preferBlob,preferImageBitmap:e.preferImageBitmap})},$n.prototype.fetchText=function(){return this.fetch({responseType:"text"})},$n.fetchText=function(e){return new $n(e).fetchText()},$n.prototype.fetchJson=function(){var e=this.fetch({responseType:"text",headers:{Accept:"application/json,*/*;q=0.01"}});if(I.defined(e))return e.then(function(e){if(I.defined(e))return JSON.parse(e)})},$n.fetchJson=function(e){return new $n(e).fetchJson()},$n.prototype.fetchXML=function(){return this.fetch({responseType:"document",overrideMimeType:"text/xml"})},$n.fetchXML=function(e){return new $n(e).fetchXML()},$n.prototype.fetchJsonp=function(e){var t;for(e=P.defaultValue(e,"callback"),Qn(this.request);t="loadJsonp"+Math.random().toString().substring(2,8),I.defined(window[t]););return function n(r,a,i){var e={};e[a]=i;r.setQueryParameters(e);var s=r.request;s.url=r.url;s.requestFunction=function(){var t=d.when.defer();return window[i]=function(e){t.resolve(e);try{delete window[i]}catch(e){window[i]=void 0}},$n._Implementations.loadAndExecuteScript(r.url,i,t),t.promise};var t=Fn.request(s);if(!I.defined(t))return;return t.otherwise(function(t){return s.state!==On.FAILED?d.when.reject(t):r.retryOnError(t).then(function(e){return e?(s.state=On.UNISSUED,s.deferred=void 0,n(r,a,i)):d.when.reject(t)})})}(this,e,t)},$n.fetchJsonp=function(e){return new $n(e).fetchJsonp(e.callbackParameterName)},$n.prototype._makeRequest=function(o){var u=this;Qn(u.request);var l=u.request;l.url=u.url,l.requestFunction=function(){var e=o.responseType,t=pn(o.headers,u.headers),n=o.overrideMimeType,r=o.method,a=o.data,i=d.when.defer(),s=$n._Implementations.loadWithXhr(u.url,e,r,a,t,i,n);return I.defined(s)&&I.defined(s.abort)&&(l.cancelFunction=function(){s.abort()}),i.promise};var e=Fn.request(l);if(I.defined(e))return e.then(function(e){return e}).otherwise(function(t){return l.state!==On.FAILED?d.when.reject(t):u.retryOnError(t).then(function(e){return e?(l.state=On.UNISSUED,l.deferred=void 0,u.fetch(o)):d.when.reject(t)})})};var tr=/^data:(.*?)(;base64)?,(.*)$/;function nr(e,t){var n=decodeURIComponent(t);return e?atob(n):n}function rr(e,t){for(var n=nr(e,t),r=new ArrayBuffer(n.length),a=new Uint8Array(r),i=0;i<n.length;i++)a[i]=n.charCodeAt(i);return r}function ar(e,t){switch(t){case"text":return e.toString("utf8");case"json":return JSON.parse(e.toString("utf8"));default:return new Uint8Array(e).buffer}}$n.prototype.fetch=function(e){return(e=Gn(e,{})).method="GET",this._makeRequest(e)},$n.fetch=function(e){return new $n(e).fetch({responseType:e.responseType,overrideMimeType:e.overrideMimeType})},$n.prototype.delete=function(e){return(e=Gn(e,{})).method="DELETE",this._makeRequest(e)},$n.delete=function(e){return new $n(e).delete({responseType:e.responseType,overrideMimeType:e.overrideMimeType,data:e.data})},$n.prototype.head=function(e){return(e=Gn(e,{})).method="HEAD",this._makeRequest(e)},$n.head=function(e){return new $n(e).head({responseType:e.responseType,overrideMimeType:e.overrideMimeType})},$n.prototype.options=function(e){return(e=Gn(e,{})).method="OPTIONS",this._makeRequest(e)},$n.options=function(e){return new $n(e).options({responseType:e.responseType,overrideMimeType:e.overrideMimeType})},$n.prototype.post=function(e,t){return n.Check.defined("data",e),(t=Gn(t,{})).method="POST",t.data=e,this._makeRequest(t)},$n.post=function(e){return new $n(e).post(e.data,{responseType:e.responseType,overrideMimeType:e.overrideMimeType})},$n.prototype.put=function(e,t){return n.Check.defined("data",e),(t=Gn(t,{})).method="PUT",t.data=e,this._makeRequest(t)},$n.put=function(e){return new $n(e).put(e.data,{responseType:e.responseType,overrideMimeType:e.overrideMimeType})},$n.prototype.patch=function(e,t){return n.Check.defined("data",e),(t=Gn(t,{})).method="PATCH",t.data=e,this._makeRequest(t)},$n.patch=function(e){return new $n(e).patch(e.data,{responseType:e.responseType,overrideMimeType:e.overrideMimeType})},($n._Implementations={}).createImage=function(i,s,o,u,l){$n.supportsImageBitmapOptions().then(function(e){return e&&l?$n.fetchBlob({url:i}).then(function(e){if(I.defined(e))return $n.createImageBitmapFromBlob(e,{flipY:u,premultiplyAlpha:!1});o.reject(new J.RuntimeError("Successfully retrieved "+i+" but it contained no content."))}).then(o.resolve):(t=i,n=s,r=o,(a=new Image).onload=function(){r.resolve(a)},a.onerror=function(e){r.reject(e)},n&&(kn.contains(t)?a.crossOrigin="use-credentials":a.crossOrigin=""),void(a.src=t));var t,n,r,a}).otherwise(o.reject)},$n.createImageBitmapFromBlob=function(e,t){return n.Check.defined("options",t),n.Check.typeOf.bool("options.flipY",t.flipY),n.Check.typeOf.bool("options.premultiplyAlpha",t.premultiplyAlpha),createImageBitmap(e,{imageOrientation:t.flipY?"flipY":"none",premultiplyAlpha:t.premultiplyAlpha?"premultiply":"none"})};var ir="undefined"==typeof XMLHttpRequest;function sr(e){if(e=P.defaultValue(e,P.defaultValue.EMPTY_OBJECT),this._dates=void 0,this._samples=void 0,this._dateColumn=-1,this._xPoleWanderRadiansColumn=-1,this._yPoleWanderRadiansColumn=-1,this._ut1MinusUtcSecondsColumn=-1,this._xCelestialPoleOffsetRadiansColumn=-1,this._yCelestialPoleOffsetRadiansColumn=-1,this._taiMinusUtcSecondsColumn=-1,this._columnCount=0,this._lastIndex=-1,this._downloadPromise=void 0,this._dataError=void 0,this._addNewLeapSeconds=P.defaultValue(e.addNewLeapSeconds,!0),I.defined(e.data))ur(this,e.data);else if(I.defined(e.url)){var t=$n.createIfNeeded(e.url),n=this;this._downloadPromise=d.when(t.fetchJson(),function(e){ur(n,e)},function(){n._dataError="An error occurred while retrieving the EOP data from the URL "+t.url+"."})}else ur(this,{columnNames:["dateIso8601","modifiedJulianDateUtc","xPoleWanderRadians","yPoleWanderRadians","ut1MinusUtcSeconds","lengthOfDayCorrectionSeconds","xCelestialPoleOffsetRadians","yCelestialPoleOffsetRadians","taiMinusUtcSeconds"],samples:[]})}function or(e,t){return rn.compare(e.julianDate,t)}function ur(e,t){if(I.defined(t.columnNames))if(I.defined(t.samples)){var n=t.columnNames.indexOf("modifiedJulianDateUtc"),r=t.columnNames.indexOf("xPoleWanderRadians"),a=t.columnNames.indexOf("yPoleWanderRadians"),i=t.columnNames.indexOf("ut1MinusUtcSeconds"),s=t.columnNames.indexOf("xCelestialPoleOffsetRadians"),o=t.columnNames.indexOf("yCelestialPoleOffsetRadians"),u=t.columnNames.indexOf("taiMinusUtcSeconds");if(n<0||r<0||a<0||i<0||s<0||o<0||u<0)e._dataError="Error in loaded EOP data: The columnNames property must include modifiedJulianDateUtc, xPoleWanderRadians, yPoleWanderRadians, ut1MinusUtcSeconds, xCelestialPoleOffsetRadians, yCelestialPoleOffsetRadians, and taiMinusUtcSeconds columns";else{var l,c=e._samples=t.samples,f=e._dates=[];e._dateColumn=n,e._xPoleWanderRadiansColumn=r,e._yPoleWanderRadiansColumn=a,e._ut1MinusUtcSecondsColumn=i,e._xCelestialPoleOffsetRadiansColumn=s,e._yCelestialPoleOffsetRadiansColumn=o,e._taiMinusUtcSecondsColumn=u,e._columnCount=t.columnNames.length,e._lastIndex=void 0;for(var d=e._addNewLeapSeconds,h=0,p=c.length;h<p;h+=e._columnCount){var m=c[h+n],y=c[h+u],v=new rn(m+Ft.MODIFIED_JULIAN_DATE_DIFFERENCE,y,Vt.TAI);if(f.push(v),d){if(y!==l&&I.defined(l)){var w=rn.leapSeconds,C=qt(w,v,or);if(C<0){var g=new Ut(v,y);w.splice(~C,0,g)}}l=y}}}}else e._dataError="Error in loaded EOP data: The samples property is required.";else e._dataError="Error in loaded EOP data: The columnNames property is required."}function lr(e,t,n,r,a){var i=n*r;a.xPoleWander=t[i+e._xPoleWanderRadiansColumn],a.yPoleWander=t[i+e._yPoleWanderRadiansColumn],a.xPoleOffset=t[i+e._xCelestialPoleOffsetRadiansColumn],a.yPoleOffset=t[i+e._yCelestialPoleOffsetRadiansColumn],a.ut1MinusUtc=t[i+e._ut1MinusUtcSecondsColumn]}function cr(e,t,n){return t+e*(n-t)}function fr(e,t,n,r,a,i,s){var o=e._columnCount;if(i>t.length-1)return s.xPoleWander=0,s.yPoleWander=0,s.xPoleOffset=0,s.yPoleOffset=0,s.ut1MinusUtc=0,s;var u=t[a],l=t[i];if(u.equals(l)||r.equals(u))return lr(e,n,a,o,s),s;if(r.equals(l))return lr(e,n,i,o,s),s;var c=rn.secondsDifference(r,u)/rn.secondsDifference(l,u),f=a*o,d=i*o,h=n[f+e._ut1MinusUtcSecondsColumn],p=n[d+e._ut1MinusUtcSecondsColumn],m=p-h;if(.5<m||m<-.5){var y=n[f+e._taiMinusUtcSecondsColumn],v=n[d+e._taiMinusUtcSecondsColumn];y!==v&&(l.equals(r)?h=p:p-=v-y)}return s.xPoleWander=cr(c,n[f+e._xPoleWanderRadiansColumn],n[d+e._xPoleWanderRadiansColumn]),s.yPoleWander=cr(c,n[f+e._yPoleWanderRadiansColumn],n[d+e._yPoleWanderRadiansColumn]),s.xPoleOffset=cr(c,n[f+e._xCelestialPoleOffsetRadiansColumn],n[d+e._xCelestialPoleOffsetRadiansColumn]),s.yPoleOffset=cr(c,n[f+e._yCelestialPoleOffsetRadiansColumn],n[d+e._yCelestialPoleOffsetRadiansColumn]),s.ut1MinusUtc=cr(c,h,p),s}function dr(e,t,n){this.heading=P.defaultValue(e,0),this.pitch=P.defaultValue(t,0),this.roll=P.defaultValue(n,0)}$n._Implementations.loadWithXhr=function(e,a,i,t,n,s,r){var o=tr.exec(e);if(null===o){if(ir)return u=e,l=a,c=i,f=n,d=s,h=global.require,p=h("url").parse(u),m="https:"===p.protocol?h("https"):h("http"),y=h("zlib"),v={protocol:p.protocol,hostname:p.hostname,port:p.port,path:p.path,query:p.query,method:c,headers:f},void m.request(v).on("response",function(t){if(t.statusCode<200||300<=t.statusCode)d.reject(new bn(t.statusCode,t,t.headers));else{var n=[];t.on("data",function(e){n.push(e)}),t.on("end",function(){var e=Buffer.concat(n);"gzip"===t.headers["content-encoding"]?y.gunzip(e,function(e,t){e?d.reject(new J.RuntimeError("Error decompressing response.")):d.resolve(ar(t,l))}):d.resolve(ar(e,l))})}}).on("error",function(e){d.reject(new bn)}).end();var u,l,c,f,d,h,p,m,y,v,w=new XMLHttpRequest;if(kn.contains(e)&&(w.withCredentials=!0),w.open(i,e,!0),I.defined(r)&&I.defined(w.overrideMimeType)&&w.overrideMimeType(r),I.defined(n))for(var C in n)n.hasOwnProperty(C)&&w.setRequestHeader(C,n[C]);I.defined(a)&&(w.responseType=a);var g=!1;return"string"==typeof e&&(g=0===e.indexOf("file://")||"undefined"!=typeof window&&"file://"===window.location.origin),w.onload=function(){if(!(w.status<200||300<=w.status)||g&&0===w.status){var e=w.response,t=w.responseType;if("HEAD"===i||"OPTIONS"===i){var n=w.getAllResponseHeaders().trim().split(/[\r\n]+/),r={};return n.forEach(function(e){var t=e.split(": "),n=t.shift();r[n]=t.join(": ")}),void s.resolve(r)}if(204===w.status)s.resolve();else if(!I.defined(e)||I.defined(a)&&t!==a)if("json"===a&&"string"==typeof e)try{s.resolve(JSON.parse(e))}catch(e){s.reject(e)}else(""===t||"document"===t)&&I.defined(w.responseXML)&&w.responseXML.hasChildNodes()?s.resolve(w.responseXML):""!==t&&"text"!==t||!I.defined(w.responseText)?s.reject(new J.RuntimeError("Invalid XMLHttpRequest response type.")):s.resolve(w.responseText);else s.resolve(e)}else s.reject(new bn(w.status,w.response,w.getAllResponseHeaders()))},w.onerror=function(e){s.reject(new bn)},w.send(t),w}s.resolve(function(e,t){t=P.defaultValue(t,"");var n=e[1],r=!!e[2],a=e[3];switch(t){case"":case"text":return nr(r,a);case"arraybuffer":return rr(r,a);case"blob":var i=rr(r,a);return new Blob([i],{type:n});case"document":return(new DOMParser).parseFromString(nr(r,a),n);case"json":return JSON.parse(nr(r,a))}}(o,a))},$n._Implementations.loadAndExecuteScript=function(e,t,n){return function(e){var t=d.when.defer(),n=document.createElement("script");n.async=!0,n.src=e;var r=document.getElementsByTagName("head")[0];return n.onload=function(){n.onload=void 0,r.removeChild(n),t.resolve()},n.onerror=function(e){t.reject(e)},r.appendChild(n),t.promise}(e).otherwise(n.reject)},($n._DefaultImplementations={}).createImage=$n._Implementations.createImage,$n._DefaultImplementations.loadWithXhr=$n._Implementations.loadWithXhr,$n._DefaultImplementations.loadAndExecuteScript=$n._Implementations.loadAndExecuteScript,$n.DEFAULT=t.freezeObject(new $n({url:"undefined"==typeof document?"":document.location.href.split("?")[0]})),sr.NONE=t.freezeObject({getPromiseToLoad:function(){return d.when()},compute:function(e,t){return I.defined(t)?(t.xPoleWander=0,t.yPoleWander=0,t.xPoleOffset=0,t.yPoleOffset=0,t.ut1MinusUtc=0):t=new It(0,0,0,0,0),t}}),sr.prototype.getPromiseToLoad=function(){return d.when(this._downloadPromise)},sr.prototype.compute=function(e,t){if(I.defined(this._samples)){if(I.defined(t)||(t=new It(0,0,0,0,0)),0===this._samples.length)return t.xPoleWander=0,t.yPoleWander=0,t.xPoleOffset=0,t.yPoleOffset=0,t.ut1MinusUtc=0,t;var n=this._dates,r=this._lastIndex,a=0,i=0;if(I.defined(r)){var s=n[r],o=n[r+1],u=rn.lessThanOrEquals(s,e),l=!I.defined(o),c=l||rn.greaterThanOrEquals(o,e);if(u&&c)return a=r,!l&&o.equals(e)&&++a,i=a+1,fr(this,n,this._samples,e,a,i,t),t}var f=qt(n,e,rn.compare,this._dateColumn);return 0<=f?(f<n.length-1&&n[f+1].equals(e)&&++f,i=a=f):(a=(i=~f)-1)<0&&(a=0),this._lastIndex=a,fr(this,n,this._samples,e,a,i,t),t}if(I.defined(this._dataError))throw new J.RuntimeError(this._dataError)},dr.fromQuaternion=function(e,t){I.defined(t)||(t=new dr);var n=2*(e.w*e.y-e.z*e.x),r=1-2*(e.x*e.x+e.y*e.y),a=2*(e.w*e.x+e.y*e.z),i=1-2*(e.y*e.y+e.z*e.z),s=2*(e.w*e.z+e.x*e.y);return t.heading=-Math.atan2(s,i),t.roll=Math.atan2(a,r),t.pitch=-H.CesiumMath.asinClamped(n),t},dr.fromDegrees=function(e,t,n,r){return I.defined(r)||(r=new dr),r.heading=e*H.CesiumMath.RADIANS_PER_DEGREE,r.pitch=t*H.CesiumMath.RADIANS_PER_DEGREE,r.roll=n*H.CesiumMath.RADIANS_PER_DEGREE,r},dr.clone=function(e,t){if(I.defined(e))return I.defined(t)?(t.heading=e.heading,t.pitch=e.pitch,t.roll=e.roll,t):new dr(e.heading,e.pitch,e.roll)},dr.equals=function(e,t){return e===t||I.defined(e)&&I.defined(t)&&e.heading===t.heading&&e.pitch===t.pitch&&e.roll===t.roll},dr.equalsEpsilon=function(e,t,n,r){return e===t||I.defined(e)&&I.defined(t)&&H.CesiumMath.equalsEpsilon(e.heading,t.heading,n,r)&&H.CesiumMath.equalsEpsilon(e.pitch,t.pitch,n,r)&&H.CesiumMath.equalsEpsilon(e.roll,t.roll,n,r)},dr.prototype.clone=function(e){return dr.clone(this,e)},dr.prototype.equals=function(e){return dr.equals(this,e)},dr.prototype.equalsEpsilon=function(e,t,n){return dr.equalsEpsilon(this,e,t,n)},dr.prototype.toString=function(){return"("+this.heading+", "+this.pitch+", "+this.roll+")"};var hr,pr,mr,yr=/((?:.*\/)|^)Cesium\.js$/;function vr(e){return"undefined"==typeof document?e:(I.defined(hr)||(hr=document.createElement("a")),hr.href=e,hr.href=hr.href,hr.href)}function wr(){return I.defined(pr)||(e="undefined"!=typeof CESIUM_BASE_URL?CESIUM_BASE_URL:"object"==typeof define&&I.defined(define.amd)&&!define.amd.toUrlUndefined&&I.defined(require.toUrl)?mn("..",xr("Core/buildModuleUrl.js")):function(){for(var e=document.getElementsByTagName("script"),t=0,n=e.length;t<n;++t){var r=e[t].getAttribute("src"),a=yr.exec(r);if(null!==a)return a[1]}}(),(pr=new $n({url:vr(e)})).appendForwardSlash()),pr;var e}function Cr(e){return vr(require.toUrl("../"+e))}function gr(e){return wr().getDerivedResource({url:e}).url}function xr(e){return I.defined(mr)||(mr="object"==typeof define&&I.defined(define.amd)&&!define.amd.toUrlUndefined&&I.defined(require.toUrl)?Cr:gr),mr(e)}function Er(e,t,n){this.x=e,this.y=t,this.s=n}function Or(e){e=P.defaultValue(e,P.defaultValue.EMPTY_OBJECT),this._xysFileUrlTemplate=$n.createIfNeeded(e.xysFileUrlTemplate),this._interpolationOrder=P.defaultValue(e.interpolationOrder,9),this._sampleZeroJulianEphemerisDate=P.defaultValue(e.sampleZeroJulianEphemerisDate,2442396.5),this._sampleZeroDateTT=new rn(this._sampleZeroJulianEphemerisDate,0,Vt.TAI),this._stepSizeDays=P.defaultValue(e.stepSizeDays,1),this._samplesPerXysFile=P.defaultValue(e.samplesPerXysFile,1e3),this._totalSamples=P.defaultValue(e.totalSamples,27426),this._samples=new Array(3*this._totalSamples),this._chunkDownloadsInProgress=[];for(var t=this._interpolationOrder,n=this._denominators=new Array(t+1),r=this._xTable=new Array(t+1),a=Math.pow(this._stepSizeDays,t),i=0;i<=t;++i){n[i]=a,r[i]=i*this._stepSizeDays;for(var s=0;s<=t;++s)s!==i&&(n[i]*=i-s);n[i]=1/n[i]}this._work=new Array(t+1),this._coef=new Array(t+1)}xr._cesiumScriptRegex=yr,xr._buildModuleUrlFromBaseUrl=gr,xr._clearBaseResource=function(){pr=void 0},xr.setBaseUrl=function(e){pr=$n.DEFAULT.getDerivedResource({url:e})},xr.getCesiumBaseUrl=wr;var _r=new rn(0,0,Vt.TAI);function Sr(e,t,n){var r=_r;return r.dayNumber=t,r.secondsOfDay=n,rn.daysDifference(r,e._sampleZeroDateTT)}function br(s,o){if(s._chunkDownloadsInProgress[o])return s._chunkDownloadsInProgress[o];var e,u=d.when.defer();s._chunkDownloadsInProgress[o]=u;var t=s._xysFileUrlTemplate;return e=I.defined(t)?t.getDerivedResource({templateValues:{0:o}}):new $n({url:xr("Assets/IAU2006_XYS/IAU2006_XYS_"+o+".json")}),d.when(e.fetchJson(),function(e){s._chunkDownloadsInProgress[o]=!1;for(var t=s._samples,n=e.samples,r=o*s._samplesPerXysFile*3,a=0,i=n.length;a<i;++a)t[r+a]=n[a];u.resolve()}),u.promise}Or.prototype.preload=function(e,t,n,r){var a=Sr(this,e,t),i=Sr(this,n,r),s=a/this._stepSizeDays-this._interpolationOrder/2|0;s<0&&(s=0);var o=i/this._stepSizeDays-this._interpolationOrder/2|0+this._interpolationOrder;o>=this._totalSamples&&(o=this._totalSamples-1);for(var u=s/this._samplesPerXysFile|0,l=o/this._samplesPerXysFile|0,c=[],f=u;f<=l;++f)c.push(br(this,f));return d.when.all(c)},Or.prototype.computeXysRadians=function(e,t,n){var r=Sr(this,e,t);if(!(r<0)){var a=r/this._stepSizeDays|0;if(!(a>=this._totalSamples)){var i=this._interpolationOrder,s=a-(i/2|0);s<0&&(s=0);var o=s+i;o>=this._totalSamples&&(s=(o=this._totalSamples-1)-i)<0&&(s=0);var u=!1,l=this._samples;if(I.defined(l[3*s])||(br(this,s/this._samplesPerXysFile|0),u=!0),I.defined(l[3*o])||(br(this,o/this._samplesPerXysFile|0),u=!0),!u){I.defined(n)?(n.x=0,n.y=0,n.s=0):n=new Er(0,0,0);var c,f,d=r-s*this._stepSizeDays,h=this._work,p=this._denominators,m=this._coef,y=this._xTable;for(c=0;c<=i;++c)h[c]=d-y[c];for(c=0;c<=i;++c){for(m[c]=1,f=0;f<=i;++f)f!==c&&(m[c]*=h[f]);m[c]*=p[c];var v=3*(s+c);n.x+=m[c]*l[v++],n.y+=m[c]*l[v++],n.s+=m[c]*l[v]}return n}}}};var Mr={},Ar={up:{south:"east",north:"west",west:"south",east:"north"},down:{south:"west",north:"east",west:"north",east:"south"},south:{up:"west",down:"east",west:"down",east:"up"},north:{up:"east",down:"west",west:"up",east:"down"},west:{up:"north",down:"south",north:"down",south:"up"},east:{up:"south",down:"north",north:"up",south:"down"}},Rr={north:[-1,0,0],east:[0,1,0],up:[0,0,1],south:[1,0,0],west:[0,-1,0],down:[0,0,-1]},Tr={},zr={east:new D.Cartesian3,north:new D.Cartesian3,up:new D.Cartesian3,west:new D.Cartesian3,south:new D.Cartesian3,down:new D.Cartesian3},qr=new D.Cartesian3,Ir=new D.Cartesian3,Pr=new D.Cartesian3;Mr.localFrameToFixedFrameGenerator=function(s,o){if(!Ar.hasOwnProperty(s)||!Ar[s].hasOwnProperty(o))throw new n.DeveloperError("firstAxis and secondAxis must be east, north, up, west, south or down.");var e,u=Ar[s][o],t=s+o;return I.defined(Tr[t])?e=Tr[t]:(e=function(e,t,n){if(I.defined(n)||(n=new Q),H.CesiumMath.equalsEpsilon(e.x,0,H.CesiumMath.EPSILON14)&&H.CesiumMath.equalsEpsilon(e.y,0,H.CesiumMath.EPSILON14)){var r=H.CesiumMath.sign(e.z);D.Cartesian3.unpack(Rr[s],0,qr),"east"!==s&&"west"!==s&&D.Cartesian3.multiplyByScalar(qr,r,qr),D.Cartesian3.unpack(Rr[o],0,Ir),"east"!==o&&"west"!==o&&D.Cartesian3.multiplyByScalar(Ir,r,Ir),D.Cartesian3.unpack(Rr[u],0,Pr),"east"!==u&&"west"!==u&&D.Cartesian3.multiplyByScalar(Pr,r,Pr)}else{(t=P.defaultValue(t,D.Ellipsoid.WGS84)).geodeticSurfaceNormal(e,zr.up);var a=zr.up,i=zr.east;i.x=-e.y,i.y=e.x,i.z=0,D.Cartesian3.normalize(i,zr.east),D.Cartesian3.cross(a,i,zr.north),D.Cartesian3.multiplyByScalar(zr.up,-1,zr.down),D.Cartesian3.multiplyByScalar(zr.east,-1,zr.west),D.Cartesian3.multiplyByScalar(zr.north,-1,zr.south),qr=zr[s],Ir=zr[o],Pr=zr[u]}return n[0]=qr.x,n[1]=qr.y,n[2]=qr.z,n[3]=0,n[4]=Ir.x,n[5]=Ir.y,n[6]=Ir.z,n[7]=0,n[8]=Pr.x,n[9]=Pr.y,n[10]=Pr.z,n[11]=0,n[12]=e.x,n[13]=e.y,n[14]=e.z,n[15]=1,n},Tr[t]=e),e},Mr.eastNorthUpToFixedFrame=Mr.localFrameToFixedFrameGenerator("east","north"),Mr.northEastDownToFixedFrame=Mr.localFrameToFixedFrameGenerator("north","east"),Mr.northUpEastToFixedFrame=Mr.localFrameToFixedFrameGenerator("north","up"),Mr.northWestUpToFixedFrame=Mr.localFrameToFixedFrameGenerator("north","west");var Dr=new nt,Nr=new D.Cartesian3(1,1,1),Ur=new Q;Mr.headingPitchRollToFixedFrame=function(e,t,n,r,a){r=P.defaultValue(r,Mr.eastNorthUpToFixedFrame);var i=nt.fromHeadingPitchRoll(t,Dr),s=Q.fromTranslationQuaternionRotationScale(D.Cartesian3.ZERO,i,Nr,Ur);return a=r(e,n,a),Q.multiply(a,s,a)};var Fr=new Q,Vr=new X;Mr.headingPitchRollQuaternion=function(e,t,n,r,a){var i=Mr.headingPitchRollToFixedFrame(e,t,n,r,Fr),s=Q.getMatrix3(i,Vr);return nt.fromRotationMatrix(s,a)};var Lr=new D.Cartesian3(1,1,1),Br=new D.Cartesian3,Wr=new Q,jr=new Q,kr=new X,Yr=new nt;Mr.fixedFrameToHeadingPitchRoll=function(e,t,n,r){t=P.defaultValue(t,D.Ellipsoid.WGS84),n=P.defaultValue(n,Mr.eastNorthUpToFixedFrame),I.defined(r)||(r=new dr);var a=Q.getTranslation(e,Br);if(D.Cartesian3.equals(a,D.Cartesian3.ZERO))return r.heading=0,r.pitch=0,r.roll=0,r;var i=Q.inverseTransformation(n(a,t,Wr),Wr),s=Q.setScale(e,Lr,jr);s=Q.setTranslation(s,D.Cartesian3.ZERO,s),i=Q.multiply(i,s,i);var o=nt.fromRotationMatrix(Q.getMatrix3(i,kr),Yr);return o=nt.normalize(o,o),dr.fromQuaternion(o,r)};var Zr=H.CesiumMath.TWO_PI/86400,Hr=new rn;Mr.computeTemeToPseudoFixedMatrix=function(e,t){var n,r=(Hr=rn.addSeconds(e,-rn.computeTaiMinusUtc(e),Hr)).dayNumber,a=Hr.secondsOfDay,i=r-2451545,s=(24110.54841+(n=43200<=a?(.5+i)/Ft.DAYS_PER_JULIAN_CENTURY:(i-.5)/Ft.DAYS_PER_JULIAN_CENTURY)*(8640184.812866+n*(.093104+-62e-7*n)))*Zr%H.CesiumMath.TWO_PI+(72921158553e-15+11772758384668e-32*(r-2451545.5))*((a+.5*Ft.SECONDS_PER_DAY)%Ft.SECONDS_PER_DAY),o=Math.cos(s),u=Math.sin(s);return I.defined(t)?(t[0]=o,t[1]=-u,t[2]=0,t[3]=u,t[4]=o,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t):new X(o,u,0,-u,o,0,0,0,1)},Mr.iau2006XysData=new Or,Mr.earthOrientationParameters=sr.NONE;var Jr=32.184;Mr.preloadIcrfFixed=function(e){var t=e.start.dayNumber,n=e.start.secondsOfDay+Jr,r=e.stop.dayNumber,a=e.stop.secondsOfDay+Jr,i=Mr.iau2006XysData.preload(t,n,r,a),s=Mr.earthOrientationParameters.getPromiseToLoad();return d.when.all([i,s])},Mr.computeIcrfToFixedMatrix=function(e,t){I.defined(t)||(t=new X);var n=Mr.computeFixedToIcrfMatrix(e,t);if(I.defined(n))return X.transpose(n,t)};var Xr=new Er(0,0,0),Gr=new It(0,0,0,0,0,0),Qr=new X,Kr=new X;Mr.computeFixedToIcrfMatrix=function(e,t){I.defined(t)||(t=new X);var n=Mr.earthOrientationParameters.compute(e,Gr);if(I.defined(n)){var r=e.dayNumber,a=e.secondsOfDay+Jr,i=Mr.iau2006XysData.computeXysRadians(r,a,Xr);if(I.defined(i)){var s=i.x+n.xPoleOffset,o=i.y+n.yPoleOffset,u=1/(1+Math.sqrt(1-s*s-o*o)),l=Qr;l[0]=1-u*s*s,l[3]=-u*s*o,l[6]=s,l[1]=-u*s*o,l[4]=1-u*o*o,l[7]=o,l[2]=-s,l[5]=-o,l[8]=1-u*(s*s+o*o);var c=X.fromRotationZ(-i.s,Kr),f=X.multiply(l,c,Qr),d=e.dayNumber-2451545,h=(e.secondsOfDay-rn.computeTaiMinusUtc(e)+n.ut1MinusUtc)/Ft.SECONDS_PER_DAY,p=.779057273264+h+.00273781191135448*(d+h);p=p%1*H.CesiumMath.TWO_PI;var m=X.fromRotationZ(p,Kr),y=X.multiply(f,m,Qr),v=Math.cos(n.xPoleWander),w=Math.cos(n.yPoleWander),C=Math.sin(n.xPoleWander),g=Math.sin(n.yPoleWander),x=r-2451545+a/Ft.SECONDS_PER_DAY,E=-47e-6*(x/=36525)*H.CesiumMath.RADIANS_PER_DEGREE/3600,O=Math.cos(E),_=Math.sin(E),S=Kr;return S[0]=v*O,S[1]=v*_,S[2]=C,S[3]=-w*_+g*C*O,S[4]=w*O+g*C*_,S[5]=-g*v,S[6]=-g*_-w*C*O,S[7]=g*O-w*C*_,S[8]=w*v,X.multiply(y,S,t)}}};var $r=new G;Mr.pointToWindowCoordinates=function(e,t,n,r){return(r=Mr.pointToGLWindowCoordinates(e,t,n,r)).y=2*t[5]-r.y,r},Mr.pointToGLWindowCoordinates=function(e,t,n,r){I.defined(r)||(r=new D.Cartesian2);var a=$r;return Q.multiplyByVector(e,G.fromElements(n.x,n.y,n.z,1,a),a),G.multiplyByScalar(a,1/a.w,a),Q.multiplyByVector(t,a,a),D.Cartesian2.fromCartesian4(a,r)};var ea=new D.Cartesian3,ta=new D.Cartesian3,na=new D.Cartesian3;Mr.rotationMatrixFromPositionVelocity=function(e,t,n,r){var a=P.defaultValue(n,D.Ellipsoid.WGS84).geodeticSurfaceNormal(e,ea),i=D.Cartesian3.cross(t,a,ta);D.Cartesian3.equalsEpsilon(i,D.Cartesian3.ZERO,H.CesiumMath.EPSILON6)&&(i=D.Cartesian3.clone(D.Cartesian3.UNIT_X,i));var s=D.Cartesian3.cross(i,t,na);return D.Cartesian3.normalize(s,s),D.Cartesian3.cross(t,s,i),D.Cartesian3.negate(i,i),D.Cartesian3.normalize(i,i),I.defined(r)||(r=new X),r[0]=t.x,r[1]=t.y,r[2]=t.z,r[3]=i.x,r[4]=i.y,r[5]=i.z,r[6]=s.x,r[7]=s.y,r[8]=s.z,r};var ra=new Q(0,0,1,0,1,0,0,0,0,1,0,0,0,0,0,1),aa=new D.Cartographic,ia=new D.Cartesian3,sa=new D.Cartesian3,oa=new X,ua=new Q,la=new Q;Mr.basisTo2D=function(e,t,n){var r=Q.getTranslation(t,sa),a=e.ellipsoid,i=a.cartesianToCartographic(r,aa),s=e.project(i,ia);D.Cartesian3.fromElements(s.z,s.x,s.y,s);var o=Mr.eastNorthUpToFixedFrame(r,a,ua),u=Q.inverseTransformation(o,la),l=Q.getMatrix3(t,oa),c=Q.multiplyByMatrix3(u,l,n);return Q.multiply(ra,c,n),Q.setTranslation(n,s,n),n},Mr.wgs84To2DModelMatrix=function(e,t,n){var r=e.ellipsoid,a=Mr.eastNorthUpToFixedFrame(t,r,ua),i=Q.inverseTransformation(a,la),s=r.cartesianToCartographic(t,aa),o=e.project(s,ia);D.Cartesian3.fromElements(o.z,o.x,o.y,o);var u=Q.fromTranslation(o,ua);return Q.multiply(ra,i,n),Q.multiply(u,n,n),n},e.BoundingSphere=N,e.Cartesian4=G,e.FeatureDetection=tt,e.GeographicProjection=a,e.Intersect=s,e.Interval=o,e.Matrix3=X,e.Matrix4=Q,e.Quaternion=nt,e.Resource=$n,e.Transforms=Mr,e.buildModuleUrl=xr,e.isArray=En});
